unit About_U;
// Description: About Dialog
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.FreeOTFE.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  OTFEFreeOTFE_U, SDUURLLabel, SDUForms;

type
  TAbout_F = class(TSDUForm)
    pbOK: TButton;
    Image1: TImage;
    lblAppID: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    lblBeta: TLabel;
    lblCrossCryptVersion: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Label3: TLabel;
    SDUURLLabel1: TSDUURLLabel;
    procedure FormShow(Sender: TObject);
  private
  public
    OTFEFreeOTFE: TOTFEFreeOTFE;
  end;

implementation

{$R *.DFM}

uses
  ShellApi,  // Needed for ShellExecute
  SDUi18n,
  SDUGeneral,
  FreeOTFEConsts;

procedure TAbout_F.FormShow(Sender: TObject);
var
  majorVersion   : integer;
  minorVersion   : integer;
  revisionVersion: integer;
  buildVersion   : integer;
  OTFEVersion: string;
begin
  SDUGetVersionInfo('', majorVersion, minorVersion, revisionVersion, buildVersion);
  lblAppID.caption := 'v'+SDUGetVersionInfoString('');
  if APP_BETA_BUILD>-1 then
    begin
    lblAppID.caption := lblAppID.caption + ' BETA '+inttostr(APP_BETA_BUILD);
    end;

  lblBeta.visible := (APP_BETA_BUILD>-1);


  if OTFEFreeOTFE.Active then
    begin
    OTFEVersion := OTFEFreeOTFE.VersionStr();
    if (OTFEVersion<>'') then
      begin
      OTFEVersion := Format(_('FreeOTFE driver: %s'), [OTFEVersion]);
      end;
    end
  else
    begin
    OTFEVersion := _('The main FreeOTFE driver is either not installed, or not started');
    end;

  lblCrossCryptVersion.caption := OTFEVersion;
  lblCrossCryptVersion.left := (self.width - lblCrossCryptVersion.width) div 2;

  Panel1.caption := '';
  Panel2.caption := '';

end;

END.

