unit FreeOTFEfmeOptions_Hotkeys;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FreeOTFEfmeOptions_Base, StdCtrls, ComCtrls, FreeOTFESettings;

type
  TfmeOptions_Hotkeys = class(TfmeOptions_Base)
    gbHotkeys: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    hkDismount: THotKey;
    ckHotkeyDismount: TCheckBox;
    ckHotkeyDismountEmerg: TCheckBox;
    hkDismountEmerg: THotKey;
    procedure FrameResize(Sender: TObject);
    procedure ckCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure EnableDisableControls(); override;
    procedure ReadSettings(config: TFreeOTFESettings); override;
    procedure WriteSettings(config: TFreeOTFESettings); override;
  end;

implementation

{$R *.dfm}

uses
  SDUGeneral;

procedure TfmeOptions_Hotkeys.FrameResize(Sender: TObject);
begin
  SDUCenterControl(gbHotkeys, ccHorizontal);
  SDUCenterControl(gbHotkeys, ccVertical, 25);
end;

procedure TfmeOptions_Hotkeys.ckCheckBoxClick(Sender: TObject);
begin
  inherited;
  EnableDisableControls();
end;

procedure TfmeOptions_Hotkeys.EnableDisableControls();
begin
  inherited;

  SDUEnableControl(hkDismount,      ckHotkeyDismount.checked);
  SDUEnableControl(hkDismountEmerg, ckHotkeyDismountEmerg.checked);
end;

procedure TfmeOptions_Hotkeys.ReadSettings(config: TFreeOTFESettings);
begin
  // Hotkeys...
  ckHotkeyDismount.checked      := config.OptHKeyEnableDismount;
  hkDismount.HotKey             := config.OptHKeyKeyDismount;
  ckHotkeyDismountEmerg.checked := config.OptHKeyEnableDismountEmerg;
  hkDismountEmerg.HotKey        := config.OptHKeyKeyDismountEmerg;

end;

procedure TfmeOptions_Hotkeys.WriteSettings(config: TFreeOTFESettings);
begin
  // Hotkeys...
  config.OptHKeyEnableDismount      := ckHotkeyDismount.checked;
  config.OptHKeyKeyDismount         := hkDismount.HotKey;
  config.OptHKeyEnableDismountEmerg := ckHotkeyDismountEmerg.checked;
  config.OptHKeyKeyDismountEmerg    := hkDismountEmerg.HotKey;

end;

END.

