unit FreeOTFEfmeOptions_SystemTray;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FreeOTFEfmeOptions_Base, StdCtrls, FreeOTFESettings;

type
  TfmeOptions_SystemTray = class(TfmeOptions_Base)
    gbSystemTrayIcon: TGroupBox;
    ckUseSystemTrayIcon: TCheckBox;
    ckMinToIcon: TCheckBox;
    ckCloseToIcon: TCheckBox;
    procedure FrameResize(Sender: TObject);
    procedure ckUseSystemTrayIconClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure EnableDisableControls(); override;
    procedure ReadSettings(config: TFreeOTFESettings); override;
    procedure WriteSettings(config: TFreeOTFESettings); override;
  end;

implementation

{$R *.dfm}

uses
  SDUGeneral;

procedure TfmeOptions_SystemTray.FrameResize(Sender: TObject);
begin
  SDUCenterControl(gbSystemTrayIcon, ccHorizontal);
  SDUCenterControl(gbSystemTrayIcon, ccVertical, 25);
end;

procedure TfmeOptions_SystemTray.ckUseSystemTrayIconClick(Sender: TObject);
begin
  inherited;
  EnableDisableControls();
end;

procedure TfmeOptions_SystemTray.EnableDisableControls();
begin
  inherited;

  SDUEnableControl(ckMinToIcon,   ckUseSystemTrayIcon.checked);
  SDUEnableControl(ckCloseToIcon, ckUseSystemTrayIcon.checked);
end;

procedure TfmeOptions_SystemTray.ReadSettings(config: TFreeOTFESettings);
begin
  // System tray icon related...
  ckUseSystemTrayIcon.checked := config.OptSystemTrayIconDisplay;
  ckMinToIcon.checked         := config.OptSystemTrayIconMinTo;
  ckCloseToIcon.checked       := config.OptSystemTrayIconCloseTo;

end;

procedure TfmeOptions_SystemTray.WriteSettings(config: TFreeOTFESettings);
begin
  // System tray icon related...
  config.OptSystemTrayIconDisplay := ckUseSystemTrayIcon.checked;
  config.OptSystemTrayIconMinTo   := ckMinToIcon.checked;
  config.OptSystemTrayIconCloseTo := ckCloseToIcon.checked;

end;

END.

