unit FreeOTFEfrmMain;
// Description:
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.FreeOTFE.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin64, StdCtrls, ComCtrls, ImgList, ExtCtrls, Grids, Menus, OTFE_U,
  OTFEFreeOTFE_U, Shredder, MouseRNGDialog_U, ActnList,
  FreeOTFESettings, SDUSystemTrayIcon, ToolWin, Buttons, XPMan,
  OTFEFreeOTFE_DriverControl,
  pkcs11_library, SDUMRUList, SDUForms;


type
  TPortableModeAction = (pmaStart, pmaStop, pmaToggle);
  TAutorunType = (arPostMount, arPreDismount, arPostDismount);

  TfrmFreeOTFEMain = class(TSDUForm)
    ilDriveIcons: TImageList;
    lvDrives: TListView;
    pmDrives: TPopupMenu;
    miPopupDismount: TMenuItem;
    mmMain: TMainMenu;
    File1: TMenuItem;
    miFreeOTFEMountFile: TMenuItem;
    miDismountMain: TMenuItem;
    miExit: TMenuItem;
    N2: TMenuItem;
    miPopupProperties: TMenuItem;
    N3: TMenuItem;
    miFreeOTFENew: TMenuItem;
    View1: TMenuItem;
    miProperties: TMenuItem;
    N1: TMenuItem;
    miRefresh: TMenuItem;
    OpenDialog: TOpenDialog;
    Help1: TMenuItem;
    About1: TMenuItem;
    miDismountAllMain: TMenuItem;
    miPopupDismountAll: TMenuItem;
    N4: TMenuItem;
    miLinuxVolume: TMenuItem;
    miLinuxNew: TMenuItem;
    miLinuxMountFile: TMenuItem;
    OTFEFreeOTFE: TOTFEFreeOTFE;
    N5: TMenuItem;
    miFreeOTFEDrivers: TMenuItem;
    miLinuxDismount: TMenuItem;
    miTools: TMenuItem;
    miOverwriteFreeSpace: TMenuItem;
    miFormat: TMenuItem;
    N6: TMenuItem;
    miPopupFormat: TMenuItem;
    miPopupOverwriteFreeSpace: TMenuItem;
    MouseRNGDialog1: TMouseRNGDialog;
    N7: TMenuItem;
    miPortableModeDrivers: TMenuItem;
    N8: TMenuItem;
    miCDBBackup: TMenuItem;
    miCDBRestore: TMenuItem;
    miCreateKeyfile: TMenuItem;
    miChangePassword: TMenuItem;
    miCDBPlaintextDump: TMenuItem;
    miCDB: TMenuItem;
    miFreeOTFEMountPartition: TMenuItem;
    miLinuxMountPartition: TMenuItem;
    N9: TMenuItem;
    miLUKSDump: TMenuItem;
    ActionList1: TActionList;
    actFreeOTFENew: TAction;
    actFreeOTFEMountFile: TAction;
    actFreeOTFEMountPartition: TAction;
    actDismount: TAction;
    actDismountAll: TAction;
    actLinuxNew: TAction;
    actLinuxMountFile: TAction;
    actLinuxMountPartition: TAction;
    actProperties: TAction;
    pmSystemTray: TPopupMenu;
    actExit: TAction;
    open1: TMenuItem;
    open2: TMenuItem;
    mountfile1: TMenuItem;
    mountpartition1: TMenuItem;
    dismountall1: TMenuItem;
    N10: TMenuItem;
    miOptions: TMenuItem;
    actDisplayConsole: TAction;
    N11: TMenuItem;
    N12: TMenuItem;
    SDUSystemTrayIcon1: TSDUSystemTrayIcon;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ilToolbarIcons: TImageList;
    actTogglePortableMode: TAction;
    StatusBar1: TStatusBar;
    actFormat: TAction;
    actOverwriteFreeSpace: TAction;
    pbtbTogglePortableMode: TToolButton;
    XPManifest1: TXPManifest;
    actDrivers: TAction;
    actRefresh: TAction;
    actListCyphers: TAction;
    Listcyphers1: TMenuItem;
    actListHashes: TAction;
    Listhashes1: TMenuItem;
    N13: TMenuItem;
    actPKCS11TokenManagement: TAction;
    PKCS11management1: TMenuItem;
    N14: TMenuItem;
    actUserGuide: TAction;
    Userguide1: TMenuItem;
    N15: TMenuItem;
    ilDriveIconOverlay: TImageList;
    actOverwriteEntireDrive: TAction;
    Overwriteentiredrive1: TMenuItem;
    Overwriteentiredrive2: TMenuItem;
    actInstallOnUSBDrive: TAction;
    N16: TMenuItem;
    CopyFreeOTFEtoUSBdrive1: TMenuItem;
    procedure actDriversExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure actRefreshExecute(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure lvDrivesResize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure lvDrivesClick(Sender: TObject);
    procedure lvDrivesDblClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure miCDBBackupClick(Sender: TObject);
    procedure miCDBRestoreClick(Sender: TObject);
    procedure miCreateKeyfileClick(Sender: TObject);
    procedure miChangePasswordClick(Sender: TObject);
    procedure miCDBPlaintextDumpClick(Sender: TObject);
    procedure miLUKSDumpClick(Sender: TObject);
    procedure actFreeOTFENewExecute(Sender: TObject);
    procedure actFreeOTFEMountFileExecute(Sender: TObject);
    procedure actFreeOTFEMountPartitionExecute(Sender: TObject);
    procedure actDismountExecute(Sender: TObject);
    procedure actDismountAllExecute(Sender: TObject);
    procedure actLinuxNewExecute(Sender: TObject);
    procedure actLinuxMountFileExecute(Sender: TObject);
    procedure actLinuxMountPartitionExecute(Sender: TObject);
    procedure actPropertiesExecute(Sender: TObject);
    procedure actExitExecute(Sender: TObject);
    procedure miOptionsClick(Sender: TObject);
    procedure actDisplayConsoleExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actTogglePortableModeExecute(Sender: TObject);
    procedure lvDrivesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure actFormatExecute(Sender: TObject);
    procedure actOverwriteFreeSpaceExecute(Sender: TObject);
    procedure pbtbTogglePortableModeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure actListCyphersExecute(Sender: TObject);
    procedure actListHashesExecute(Sender: TObject);
    procedure actOverwriteEntireDriveExecute(Sender: TObject);
    procedure actPKCS11TokenManagementExecute(Sender: TObject);
    procedure actUserGuideExecute(Sender: TObject);
    procedure actInstallOnUSBDriveExecute(Sender: TObject);

  private
    // Flag to indicate that the login session is about to end
    EndSessionFlag: boolean;
    // Flag to indicate that the executable is about to exit
    ShuttingDownFlag: boolean;

    TempCypherDriver: string;
    TempCypherGUID: TGUID;
    TempCypherDetails: TFreeOTFECypher_v3;
    TempCypherKey: string;
    TempCypherEncBlockNo: int64;

    IconMounted: TIcon;
    IconUnmounted: TIcon;

    // We cache this information as it take a *relativly* long time to get it
    // from the OTFE component.
    CountPortableDrivers: integer;

    PKCS11Library: TPKCS11Library;
  protected
    AllowUACEsclation: boolean;

    function HandleCommandLineOpts_Portable(): integer;
    function HandleCommandLineOpts_DriverControl(): integer;
    function HandleCommandLineOpts_DriverControl_GUI(): integer;
    function HandleCommandLineOpts_DriverControl_Install(driverControlObj: TOTFEFreeOTFEDriverControl): integer;
    function HandleCommandLineOpts_DriverControl_Uninstall(driverControlObj: TOTFEFreeOTFEDriverControl): integer;
    function HandleCommandLineOpts_DriverControl_Count(driverControlObj: TOTFEFreeOTFEDriverControl): integer;
    function HandleCommandLineOpts_Count(): integer;
    function HandleCommandLineOpts_Mount(): integer;
    function HandleCommandLineOpts_Dismount(): integer;

    procedure ReloadSettings();

    procedure SetupOTFEComponent();
    function  ActivateFreeOTFEComponent(suppressMsgs: boolean): boolean;
    procedure DeactivateFreeOTFEComponent();

    procedure SetupPKCS11(suppressMsgs: boolean);
    procedure ShutdownPKCS11();
    procedure PKCS11SlotEvent(Sender: TObject; SlotID: integer);
    procedure PKCS11TokenRemoved(SlotID: integer);
    procedure PKCS11TokenInserted(SlotID: integer);

    procedure AddToMRUList(filenames: TStringList);
    procedure RefreshMRUList();
    procedure MRUListItemClicked(mruList: TSDUMRUList; idx: integer);

    procedure InitializeDrivesDisplay();
    procedure RefreshDrives();
    function  DetermineDriveOverlay(volumeInfo: TOTFEFreeOTFEVolumeInfo): integer;
    function  AddIconForDrive(driveLetter: char; overlayIdx: integer): integer;

    procedure SetStatusBarTextNormal();
    procedure SetStatusBarText(statusText: string);
    procedure EnableDisableControls();
    function  GetDriveLetterFromLVItem(listItem: TListItem): char;

    procedure DumpDetailsToFile(LUKSDump: boolean);

    procedure ResizeWindow();

    procedure OverwriteSelectedDrives(overwriteEntireDrive: boolean);

    procedure ExploreDrive(driveLetter: char);

    procedure MountFilesDetectLUKS(
      fileToMount: string;
      readOnly: boolean;
      defaultType: TDragDropFileType
    ); overload;
    procedure MountFilesDetectLUKS(
      filesToMount: TStringList;
      readOnly: boolean;
      defaultType: TDragDropFileType
    ); overload;
    procedure MountFiles(mountAsSystem: TDragDropFileType; filename: string; readOnly: boolean); overload;
    procedure MountFiles(mountAsSystem: TDragDropFileType; filenames: TStringList; readOnly: boolean); overload;

    procedure DriveProperties();

    function  DismountSelected(): boolean;
    function  DismountAll(isEmergency: boolean = FALSE): boolean;
    function  DismountDrives(dismountDrives: string; isEmergency: boolean): boolean;
    procedure ReportDrivesNotDismounted(drivesRemaining: string; isEmergency: boolean);
    
    procedure GetAllDriversUnderCWD(driverFilenames: TStringList);

    function  PortableModeSet(setTo: TPortableModeAction; suppressMsgs: boolean): boolean;
    function  _PortableModeStart(suppressMsgs: boolean): boolean;
    function  _PortableModeStop(suppressMsgs: boolean): boolean;
    function  _PortableModeToggle(suppressMsgs: boolean): boolean;

    // System tray icon related...
    procedure SystemTrayIconDismount(Sender: TObject);
    procedure DestroySysTrayIconMenuitems();

    // Hotkey related...
    procedure SetupHotKeys();
    procedure EnableHotkey(hotKey: TShortCut; hotKeyIdent: integer);
    procedure DisableHotkey(hotKeyIdent: integer);

    procedure ChangeCWDToSafeDir();

{$IFDEF VER180}
{$IFNDEF VER185}
    // Vista fix for Delphi 2006 only
    procedure WMSyscommand(var Message: TWmSysCommand); message WM_SYSCOMMAND;
{$ENDIF}
{$ENDIF}

    procedure AddUACShieldIcons();

    procedure UACEscalateForDriverInstallation();
    procedure UACEscalateForPortableMode(portableAction: TPortableModeAction; suppressMsgs: boolean);
    procedure UACEscalate(cmdLineParams: string; suppressMsgs: boolean);

    procedure AutoRunExecute(autorun: TAutorunType; driveLetter: char; isEmergency: boolean);

  public
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure WMDeviceChange(var Msg : TMessage); message WM_DEVICECHANGE;
    procedure WMQueryEndSession(var msg: TWMQueryEndSession); message WM_QUERYENDSESSION;
    procedure WMEndSession(var msg: TWMEndSession); message WM_ENDSESSION;

    procedure GenerateOverwriteData(Sender: TObject; passNumber: integer; bytesRequired: cardinal; var outputBlock: TShredBlock);

    procedure InitApp();

    function MessageHook(var msg: TMessage): boolean;

    procedure DisplayDriverControlDlg();

    // Handle any command line options; returns TRUE if command line options
    // were passed through
    function HandleCommandLineOpts(var exitCode: integer): boolean;

{$IFDEF VER180}
{$IFNDEF VER185}
    // Vista fix for Delphi 2006 only
    procedure CreateParams(var Params: TCreateParams); override;
{$ENDIF}
{$ENDIF}

  end;

var
  frmFreeOTFEMain: TfrmFreeOTFEMain;
  GLOBAL_VAR_WM_FREEOTFE_RESTORE: cardinal;
  GLOBAL_VAR_WM_FREEOTFE_REFRESH: cardinal;

implementation

{$R *.DFM}
{$R FreeOTFESystemTrayIcons.dcr}

uses
  ShellApi,  // Required for SHGetFileInfo
  Commctrl,  // Required for ImageList_GetIcon
  ComObj,  // Required for StringToGUID
  Math,  // Required for min
  SDUGeneral,
  SDUDialogs,
  About_U,
  SDUi18n,
  FreeOTFEfrmVolProperties,
  FreeOTFEfrmSelectOverwriteMethod,
  FreeOTFEfrmCDBDump,
  FreeOTFEfrmCDBBackupRestore,
  FreeOTFEfrmOptions,
  FreeOTFEfrmInstallOnUSBDrive,
  OTFEConsts_U,
  OTFEFreeOTFE_DriverAPI,
  SDUFileIterator_U,
  FreeOTFEfrmGridReport_Hash,
  FreeOTFEfrmGridReport_Cypher,
  pkcs11_slot,
  OTFEFreeOTFE_PKCS11;


resourcestring
  AUTORUN_POST_MOUNT    = 'post mount';
  AUTORUN_PRE_MOUNT     = 'pre dismount';
  AUTORUN_POST_DISMOUNT = 'post dismount';
const
  AUTORUN_TITLE : array [TAutorunType] of string = (
                                                    AUTORUN_POST_MOUNT,
                                                    AUTORUN_PRE_MOUNT,
                                                    AUTORUN_POST_DISMOUNT
                                                   );

resourcestring
  TEXT_NEED_ADMIN = 'You need administrator privileges in order to carry out this operation.';


const
  // Format disk related functions ripped from the Unofficial Delphi FAQ (UDF)
  SHFMT_ID_DEFAULT        = $FFFF;
  // Formating options
  SHFMT_OPT_QUICKFORMAT   = $0000;
  SHFMT_OPT_FULL          = $0001;
  SHFMT_OPT_SYSONLY       = $0002;
  // Error codes
  SHFMT_ERROR             = $FFFFFFFF;
  SHFMT_CANCEL            = $FFFFFFFE;
  SHFMT_NOFORMAT          = $FFFFFFFD;

  R_ICON_MOUNTED   = 'MOUNTED';
  R_ICON_UNMOUNTED = 'UNMOUNTED';

  POPUP_DISMOUNT = 'Dismount %s: %s'; 

  TAG_SYSTRAYICON_POPUPMENUITEMS           = $5000; // Note: LSB will be the drive letter
  TAG_SYSTRAYICON_POPUPMENUITEMS_DRIVEMASK =   $FF; // LSB mask for drive letter

  HOTKEY_TEXT_NONE = '(None)';
  HOTKEY_IDENT_DISMOUNT      = 1;
  HOTKEY_IDENT_DISMOUNTEMERG = 2;

  DEVICE_PREFIX = '\Device';

  USERGUIDE_LOCAL = '.\docs\index.htm';
  USERGUIDE_ONLINE = 'http://www.FreeOTFE.org/docs';

  // Overlay icons; these MUST be kept in sync with the icons in
  // ilDriveIconOverlay
  OVERLAY_IMGIDX_NONE        = -1;
  OVERLAY_IMGIDX_PKCS11TOKEN =  0;
  OVERLAY_IMGIDX_LINUX       =  1;

  AUTORUN_SUBSTITUTE_DRIVE = '%DRIVE';

  // Command line switch indicator
  // Note: Only used when creating command lines; parsing them is more flexable
  CMDLINE_SWITCH_IND = '/';

  // Command line parameters...
  CMDLINE_NOUACESCALATE    = 'noUACescalate';
  CMDLINE_DRIVERCONTROL    = 'drivercontrol';
  CMDLINE_PORTABLE         = 'portable';
  CMDLINE_START            = 'start';
  CMDLINE_ON               = 'on';
  CMDLINE_STOP             = 'stop';
  CMDLINE_OFF              = 'off';
  CMDLINE_TOGGLE           = 'toggle';
  CMDLINE_MOUNT            = 'mount';
  CMDLINE_FREEOTFE         = 'freeotfe';
  CMDLINE_LINUX            = 'linux';
  CMDLINE_VOLUME           = 'volume';
  CMDLINE_READONLY         = 'readonly';
  CMDLINE_DISMOUNT         = 'dismount';
  CMDLINE_FORCE            = 'force';
  CMDLINE_ALL              = 'all';
  CMDLINE_INSTALL          = 'install';
  CMDLINE_UNINSTALL        = 'uninstall';
  CMDLINE_PASSWORD         = 'password';
  CMDLINE_SILENT           = 'silent';
  CMDLINE_COUNT            = 'count';
  CMDLINE_MOUNTED          = 'mounted';
  CMDLINE_GUI              = 'gui';
  CMDLINE_TYPE             = 'type';
  CMDLINE_TOTAL            = 'total';
  CMDLINE_DRIVERSPORTABLE  = 'portable';
  CMDLINE_DRIVERSINSTALLED = 'installed';
  CMDLINE_DRIVERNAME       = 'drivername';
  CMDLINE_FILENAME         = 'filename';
  CMDLINE_DRIVE            = 'drive';
  CMDLINE_KEYFILE          = 'keyfile';
  CMDLINE_LESFILE          = 'lesfile';
  CMDLINE_NOEXIT           = 'noexit';

  // Command line return values...
  CMDLINE_SUCCESS                            =   0;
  CMDLINE_EXIT_INVALID_CMDLINE               = 100;
  CMDLINE_EXIT_UNABLE_TO_CONNECT             = 101;
  CMDLINE_EXIT_UNABLE_TO_MOUNT               = 102;
  CMDLINE_EXIT_UNABLE_TO_DISMOUNT            = 103;
  CMDLINE_EXIT_UNABLE_TO_START_PORTABLE_MODE = 104;
  CMDLINE_EXIT_UNABLE_TO_STOP_PORTABLE_MODE  = 105;
  CMDLINE_EXIT_FILE_NOT_FOUND                = 106;
  CMDLINE_EXIT_ADMIN_PRIVS_NEEDED            = 106;
  CMDLINE_EXIT_UNKNOWN_ERROR                 = 999;


// External function in shell32.dll
function SHFormatDrive(Handle: HWND; Drive, ID, Options: Word): LongInt;
            stdcall; external 'shell32.dll' name 'SHFormatDrive'


// This procedure is called after OnCreate, and immediatly before the
// Application.Run() is called
procedure TfrmFreeOTFEMain.InitApp();
var
  goForStartPortable: boolean;
begin
  // Hook Windows messages first; if we're running under Vista and the user UAC
  // escalates to start portable mode (below), we don't want to miss any
  // refresh messages the escalated process may send us!
  Application.HookMainWindow(MessageHook);

  InitializeDrivesDisplay();
  // We call EnableDisableControls(...) at this point, to display the
  // toolbar/statusbar as needed
  EnableDisableControls();

  if not(ActivateFreeOTFEComponent(TRUE)) then
    begin
    goForStartPortable := Settings.OptAutoStartPortable;
    if not(goForStartPortable) then
      begin
      goForStartPortable := (SDUMessageDlg(
               _('The main FreeOTFE driver does not appear to be installed/running on this computer')+SDUCRLF+
               SDUCRLF+
               _('Would you like to start FreeOTFE in portable mode?'),
               mtConfirmation,
               [mbYes, mbNo],
               0
              ) = mrYes);
      end;

    if goForStartPortable then
      begin
      PortableModeSet(pmaStart, FALSE);
      end
    else
      begin
      SDUMessageDlg(
             _('Please see the "installation" section of the accompanying documentation for instructions on how to install the FreeOTFE drivers.'),
             mtInformation,
             [mbOK],
             0
            );
      end;

    end;

  RefreshDrives();
  EnableDisableControls();
  SetupHotKeys();
  SetupPKCS11(FALSE);

end;

procedure TfrmFreeOTFEMain.RefreshDrives();
var
  ListItem: TListItem;
  driveIconNum: integer;
  i: integer;
  volumeInfo: TOTFEFreeOTFEVolumeInfo;
  mounted: string;
  miTmp: TMenuItem;
  strVolID: string;
  overlayIdx: integer;
begin
  // Flush any caches in case a separate instance of FreeOTFE running from the
  // commandline, with escalated UAC changed the drivers installed/running
  OTFEFreeOTFE.CachesFlush();

  // Cleardown all...

  // ...Main FreeOTFE window list...
  lvDrives.Items.Clear();
  ilDriveIcons.Clear();

  // ...System tray icon drives list...
  DestroySysTrayIconMenuitems();

  // In case the drivers have been stopped/started recently, we bounce the
  // FreeOTFE component up and down (silently!)
  DeactivateFreeOTFEComponent();
  ActivateFreeOTFEComponent(TRUE);

  /// ...and repopulate
  if OTFEFreeOTFE.Active then
    begin
    mounted := OTFEFreeOTFE.DrivesMounted();

    for i:=1 to length(mounted) do
      begin
      // ...Main FreeOTFE window list...
      if OTFEFreeOTFE.GetVolumeInfo(mounted[i], volumeInfo) then
        begin
        ListItem := lvDrives.Items.Add;
        ListItem.Caption := '     '+mounted[i]+':';
        ListItem.SubItems.Add(volumeInfo.Filename);
        overlayIdx := DetermineDriveOverlay(volumeInfo);
        driveIconNum := AddIconForDrive(mounted[i], overlayIdx);
        if (driveIconNum>=0) then
          begin
          ListItem.ImageIndex := driveIconNum;
          end;
        end
      else
        begin
        // Strange... The drive probably got dismounted between getting the
        // list of mounted drives, and querying them for more information...
        end;


        // The volume ID/label
        strVolID := SDUVolumeID(mounted[i]);
        if strVolID<>'' then
          begin
          strVolID := '['+strVolID+']';
          end;

        // ...System tray icon popup menu...
        miTmp := TMenuItem.Create(nil);
        miTmp.Tag := TAG_SYSTRAYICON_POPUPMENUITEMS or ord(mounted[i]);
                                                      // We tag our menuitems
                                                      // in order that we can
                                                      // know which ones to
                                                      // remove later
        miTmp.OnClick := SystemTrayIconDismount;
        miTmp.AutoHotkeys := maManual;  // Otherwise the hotkeys added
                                        // automatically can interfere with
                                        // examing the caption to get the drive
                                        // letter when clicked on
        miTmp.Caption := Format(POPUP_DISMOUNT, [mounted[i], strVolID]);
        pmSystemTray.Items.Insert((i-1), miTmp);
      end;

      // Insert a divider into the system tray icon's popup menu after the
      // drives are listed
      if (length(mounted) > 0) then
        begin
        miTmp := TMenuItem.Create(nil);
        miTmp.Caption := '-';
        pmSystemTray.Items.Insert(length(mounted), miTmp);
        end;

    end;


  CountPortableDrivers := OTFEFreeOTFE.DriversInPortableMode();
  EnableDisableControls();

end;


// Tear down system tray icon popup menu menuitems previously added
procedure TfrmFreeOTFEMain.DestroySysTrayIconMenuitems();
var
  i: integer;
  miTmp: TMenuItem;
begin
  for i:=(pmSystemTray.Items.count-1) downto 0 do
    begin
    if ((pmSystemTray.Items[i].Tag and TAG_SYSTRAYICON_POPUPMENUITEMS) = TAG_SYSTRAYICON_POPUPMENUITEMS) then
      begin
      miTmp := pmSystemTray.Items[i];
      pmSystemTray.Items.Delete(i);
      miTmp.Free();
      end;
    end;
end;


procedure TfrmFreeOTFEMain.SystemTrayIconDismount(Sender: TObject);
var
  miDismount: TMenuItem;
  drive: char;
begin
  miDismount := TMenuItem(Sender);

  drive := chr(miDismount.Tag and TAG_SYSTRAYICON_POPUPMENUITEMS_DRIVEMASK);

  DismountDrives(drive, FALSE);
end;


function TfrmFreeOTFEMain.DetermineDriveOverlay(volumeInfo: TOTFEFreeOTFEVolumeInfo): integer;
var
  retval: integer;
begin
  retval := OVERLAY_IMGIDX_NONE;

  if volumeInfo.MetaDataStructValid then
    begin
    if (volumeInfo.MetaDataStruct.PKCS11SlotID <> PKCS11_NO_SLOT_ID) then
      begin
      retval := OVERLAY_IMGIDX_PKCS11TOKEN;
      end
    else if volumeInfo.MetaDataStruct.LinuxVolume then
      begin
      retval := OVERLAY_IMGIDX_LINUX;
      end;
    end;

  Result := retval;
end;


// Add an icon to represent the specified drive
// overlayIdx - Set to an image index within ilDriveIconOverlay, or -1 for no
//              overlay
// Returns: The icon's index in ilDriveIcons, or -1 on error
function TfrmFreeOTFEMain.AddIconForDrive(driveLetter: char; overlayIdx: integer): integer;
var
  iconIdx: integer;
  anIcon: TIcon;
  shfi: SHFileInfo;
  imgListHandle: THandle;
  iconHandle: HICON;
  tmpDrivePath: string;
  overlayIcon: TIcon;
  listBkColor: TColor;
begin
  iconIdx := -1;
  
  // Create a suitable icon to represent the drive
  tmpDrivePath := driveLetter+':\';
  imgListHandle := SHGetFileInfo(
                                 PChar(tmpDrivePath),
                                 0,
                                 shfi,
                                 sizeof(shfi),
                                 SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
//                                 SHGFI_DISPLAYNAME

  if imgListHandle<>0 then
    begin
    iconHandle := ImageList_GetIcon(imgListHandle, shfi.iIcon, ILD_NORMAL);
    if (iconHandle<>0) then
      begin
      anIcon:= TIcon.Create();
      try
        anIcon.ReleaseHandle();

        anIcon.handle := iconHandle;

        if (ilDriveIcons.Width<anIcon.Width) then
          begin
          ilDriveIcons.Width := anIcon.Width;
          end;
        if (ilDriveIcons.Height<anIcon.Height) then
          begin
          ilDriveIcons.Height := anIcon.Height;
          end;

        if (overlayIdx >= 0) then
          begin
          overlayIcon := TIcon.Create();
          try
            ilDriveIconOverlay.GetIcon(overlayIdx, overlayIcon);
            SDUOverlayIcon(anIcon, overlayIcon);
          finally
            overlayIcon.Free();
          end;
          end;

        // We switch the background colour so that (Under Windows XP, unthemed,
        // at least) the icons don't appear to have a black border around them
        listBkColor := ilDriveIcons.BkColor;
        ilDriveIcons.BkColor := lvDrives.Color;
        iconIdx := ilDriveIcons.addicon(anIcon);
        ilDriveIcons.BkColor := listBkColor;


        anIcon.ReleaseHandle();
        DestroyIcon(iconHandle);
      finally
        anIcon.Free();
      end;

      end;
    end;


  Result := iconIdx;

end;

procedure TfrmFreeOTFEMain.InitializeDrivesDisplay();
var
  tmpColumn: TListColumn;
begin
  // Listview setup...
  lvDrives.SmallImages := ilDriveIcons;
  lvDrives.RowSelect:= TRUE;
  lvDrives.MultiSelect:= TRUE;
  lvDrives.showcolumnheaders := TRUE;
  lvDrives.ReadOnly := TRUE;
  lvDrives.ViewStyle := vsReport;
//    lvDrives.ViewStyle := vsIcon;
//    lvDrives.ViewStyle := vsList;
  lvDrives.IconOptions.Arrangement := iaTop;


  // Listview columns...
  tmpColumn := lvDrives.Columns.Add;
  tmpColumn.Caption := _('Drive');
  tmpColumn.width := 100;

//    tmpColumn.minwidth := lvDrives.width;
  tmpColumn := lvDrives.Columns.Add;
  tmpColumn.Caption := _('Volume');
  tmpColumn.width := lvDrives.clientwidth - lvDrives.columns[0].width - ilDriveIcons.width;


// xxx - shouldn't this work?     NewColumn.autosize := TRUE;
// xxx - shouldn't this work?     NewColumn.minwidth := lvDrives.clientwidth - lvDrives.columns[0].width - ilDriveIcons.width;


// xxx - use destroyimage or whatever it was to cleardown the **imagelist**

end;


// Add an icon to represent the specified drive
// Returns: The icon's index in ilDriveIcons, or -1 on error
procedure TfrmFreeOTFEMain.AddUACShieldIcons();
var
  iconIdx: integer;
  anIcon: TIcon;
  iconHandle: HICON;
begin
  // Create a suitable icon to represent the drive
  iconHandle := LoadImage(
                          0,
                          PChar(UAC_IDI_SHIELD),
                          IMAGE_ICON,
                          ilToolbarIcons.Width,
                          ilToolbarIcons.Height,
                          (LR_CREATEDIBSECTION or LR_SHARED)
                         );
  if (iconHandle <> 0) then
    begin
    anIcon:= TIcon.Create();
    try
      anIcon.ReleaseHandle();

      anIcon.handle := iconHandle;
      {
      if (ilToolbarIcons.Width < anIcon.Width) then
        begin
        ilToolbarIcons.Width := anIcon.Width;
        end;
      if (ilToolbarIcons.Height < anIcon.Height) then
        begin
        ilToolbarIcons.Height := anIcon.Height;
        end;
       }
      iconIdx := ilToolbarIcons.AddIcon(anIcon);

      anIcon.ReleaseHandle();
      DestroyIcon(iconHandle);
    finally
      anIcon.Free();
    end;

    // Set icons on menuitems
    if (iconIdx >= 0) then
      begin
      miFreeOTFEDrivers.ImageIndex := iconIdx;
      miPortableModeDrivers.ImageIndex := iconIdx;
      actFormat.ImageIndex := iconIdx;
      end;

    end;

end;


procedure TfrmFreeOTFEMain.FormCreate(Sender: TObject);
begin
{$IFDEF FREEOTFE_DEBUG}
  OTFEFreeOTFE.DebugShowMessage := FALSE;  // xxx - disable showmessages(...) of debug if built with debug on
{$ENDIF}

  if SDUOSVistaOrLater() then
    begin
{$IFDEF VER180}
{$IFNDEF VER185}
    // Vista fix for Delphi 2006 only
    ShowWindow(Application.Handle, SW_HIDE);
    SetWindowLong(
                  Application.Handle,
                  GWL_EXSTYLE,
                  (
                   GetWindowLong(Application.Handle, GWL_EXSTYLE) and not WS_EX_APPWINDOW or WS_EX_TOOLWINDOW
                  )
                 );
    ShowWindow(Application.Handle, SW_SHOW);
{$ENDIF}
{$ENDIF}

    // Mark as appropriate with UAC "shield" icons
    AddUACShieldIcons();
    end;

  // Prevent endless loops of UAC escalation...
  AllowUACEsclation := FALSE;

  // Reload settings to ensure any any components are setup, etc
  ReloadSettings();
    
  EndSessionFlag := FALSE;
  ShuttingDownFlag := FALSE;

  self.Caption := Application.Title;
  SDUSystemTrayIcon1.Tip := Application.Title;

  IconMounted:= TIcon.Create();
  IconMounted.Handle := LoadImage(hInstance, PChar(R_ICON_MOUNTED), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
  IconUnmounted:= TIcon.Create();
  IconUnmounted.Handle := LoadImage(hInstance, PChar(R_ICON_UNMOUNTED), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

  // We set these to invisible so that if they're disabled by the user
  // settings, it doens't flicker on them off
  ToolBar1.Visible := FALSE;
  Statusbar1.Visible := FALSE;

  // Give the user a clue
  ToolBar1.ShowHint := TRUE;

  ToolBar1.Indent := 5;

  CountPortableDrivers := -1;

  StatusBar1.SimplePanel := TRUE;

end;

procedure TfrmFreeOTFEMain.actRefreshExecute(Sender: TObject);
begin
  RefreshDrives();

end;

procedure TfrmFreeOTFEMain.About1Click(Sender: TObject);
var
  aboutDlg: TAbout_F;
begin
  aboutDlg:= TAbout_F.Create(self);
  try
    aboutDlg.OTFEFreeOTFE := OTFEFreeOTFE;
    aboutDlg.ShowModal();
  finally
    aboutDlg.Free();
  end;

end;

procedure TfrmFreeOTFEMain.lvDrivesResize(Sender: TObject);
begin
  ResizeWindow();

end;


procedure TfrmFreeOTFEMain.FormResize(Sender: TObject);
begin
  ResizeWindow();

end;


// Resize the columns in the drives list so the 2nd column fills out...
procedure TfrmFreeOTFEMain.ResizeWindow();
var
  tmpColumn: TListColumn;
begin
  if lvDrives.columns.count>1 then
    begin
    tmpColumn := lvDrives.columns[1];
    tmpColumn.width := lvDrives.clientwidth - lvDrives.columns[0].width - ilDriveIcons.width;
    end;

end;

procedure TfrmFreeOTFEMain.SetupOTFEComponent();
begin
  OTFEFreeOTFE.AdvancedMountDlg := Settings.OptAdvancedMountDlg;
  OTFEFreeOTFE.RevertVolTimestamps := Settings.OptRevertVolTimestamps;
  OTFEFreeOTFE.DefaultDriveLetter := Settings.OptDefaultDriveLetter;
  OTFEFreeOTFE.PasswordChar := '*';
  if Settings.OptShowPasswords then
    begin
    OTFEFreeOTFE.PasswordChar := #0;
    end;

  // OTFEFreeOTFE.PKCS11Library setup in SetupPKCS11(...)

end;

// Reload settings, setting up any components as needed
procedure TfrmFreeOTFEMain.ReloadSettings();
begin
  SDUSetLanguage(Settings.OptLanguageCode);
  try
    SDURetranslateComponent(self);
  except
    on E:Exception do
      begin
      SDUTranslateComponent(self);
      end;
  end;
  self.Caption := Application.Title;

  SetupPKCS11(FALSE);
  SetupOTFEComponent();

  SDUSystemTrayIcon1.Active := Settings.OptSystemTrayIconDisplay;
  SDUSystemTrayIcon1.MinimizeToIcon := Settings.OptSystemTrayIconMinTo;

  SetupHotKeys();
  RefreshMRUList();

end;

procedure TfrmFreeOTFEMain.MountFiles(mountAsSystem: TDragDropFileType; filename: string; readOnly: boolean);
var
  tmpFilenames: TStringList;
begin
  tmpFilenames:= TStringList.Create();
  try
    tmpFilenames.Add(filename);
    MountFiles(mountAsSystem, tmpFilenames, readOnly);
  finally
    tmpFilenames.Free();
  end;
end;

procedure TfrmFreeOTFEMain.MountFiles(mountAsSystem: TDragDropFileType; filenames: TStringList; readOnly: boolean);
var
  i: integer;
  mountedAs: string;
  msg: string;
  mountedOK: boolean;
begin
// Why was this in here?!
//  ReloadSettings();

  AddToMRUList(filenames);

  if (mountAsSystem = ftFreeOTFE) then
    begin
    mountedOK:= OTFEFreeOTFE.MountFreeOTFE(filenames, mountedAs, readOnly);
    end
  else if (mountAsSystem = ftLinux) then
    begin
    mountedOK:= OTFEFreeOTFE.MountLinux(filenames, mountedAs, readOnly);
    end
  else
    begin
    mountedOK:= OTFEFreeOTFE.Mount(filenames, mountedAs, readOnly);
    end;

  if not(mountedOK) then
    begin
    if (OTFEFreeOTFE.LastErrorCode <> OTFE_ERR_USER_CANCEL) then
      begin
      SDUMessageDlg(
                    _('Unable to mount volume.')+SDUCRLF+
                    SDUCRLF+
                    _('Please check your password and settings, and try again.'),
                    mtError,
                    [mbOK],
                    0
                   );
      end;
    end
  else
    begin
    msg := msg + PrettyPrintDriveLetters(mountedAs);
    if (CountValidDrives(mountedAs) = 1) then
      begin
      msg := Format(_('Your FreeOTFE volume has been mounted as drive: %s'), [msg]);
      end
    else
      begin
      msg := Format(_('Your FreeOTFE volumes have been mounted as drives: %s'), [msg]);
      end;

    RefreshDrives();
    SDUMessageDlg(msg, mtInformation, [mbOK], 0);

    for i:=1 to length(mountedAs) do
      begin
      if Settings.OptExploreAfterMount then
        begin
        ExploreDrive(mountedAs[i]);
        end;

      AutoRunExecute(arPostMount, mountedAs[i], FALSE);
      end;

    end;

end;

// If called with "nil", just refresh the menuitems shown
procedure TfrmFreeOTFEMain.AddToMRUList(filenames: TStringList);
begin
  if (filenames <> nil) then
    begin
    Settings.OptMRUList.Add(filenames);

    if (Settings.OptSaveSettings <> slNone) then
      begin
      Settings.Save();
      end;
    end;

  RefreshMRUList();

end;

procedure TfrmFreeOTFEMain.RefreshMRUList();
begin
  // Refresh menuitems...
  Settings.OptMRUList.RemoveMenuItems(mmMain);
  Settings.OptMRUList.InsertAfter(miFreeOTFEDrivers);
  Settings.OptMRUList.OnClick := MRUListItemClicked;

end;

procedure TfrmFreeOTFEMain.MRUListItemClicked(mruList: TSDUMRUList; idx: integer);

begin
  MountFilesDetectLUKS(mruList.Items[idx], FALSE, Settings.OptDragDropFileType);
end;

// Handle files being dropped onto the form from (for example) Windows Explorer.
// Files dropped onto the form should be treated as though the user is trying
// to mount them as volume files
procedure TfrmFreeOTFEMain.WMDropFiles(var Msg: TWMDropFiles);
var
  buffer: array[0..MAX_PATH] of Char;
  numFiles: longint;
  i: integer;
  filesToMount: TStringList;
begin
  try
    // Bring our window to the foreground
    SetForeGroundWindow(self.handle);

    // Handle the dropped files
    numFiles := DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);
    filesToMount := TStringList.Create();
    try
      for i:=0 to (numFiles-1) do
        begin
        DragQueryFile(msg.Drop,
                      i,
                      @buffer,
                      sizeof(buffer));
        filesToMount.Add(buffer);
        end;

      MountFilesDetectLUKS(filesToMount, FALSE, Settings.OptDragDropFileType);

      Msg.Result := 0;
    finally
      filesToMount.Free();
    end;
  finally
    DragFinish(Msg.Drop);
  end;

end;

procedure TfrmFreeOTFEMain.MountFilesDetectLUKS(
      fileToMount: string;
      readOnly: boolean;
      defaultType: TDragDropFileType
    );
var
  tmpFilenames: TStringList;
begin
  tmpFilenames:= TStringList.Create();
  try
    tmpFilenames.Add(fileToMount);
    MountFilesDetectLUKS(
                         tmpFilenames,
                         readOnly,
                         defaultType
                        );
  finally
    tmpFilenames.Free();
  end;
end;


procedure TfrmFreeOTFEMain.MountFilesDetectLUKS(
  filesToMount: TStringList;
  readOnly: boolean;
  defaultType: TDragDropFileType
);
var
  i: integer;
  mountType: TDragDropFileType;
begin
  // If *all* of the volumes selected are LUKS volumes, mount as LUKS.
  // Otherwise mount the type passed into this function
  // (The chances of a FreeOTFE volume starting with the LUKS signature are
  // pretty low, so this is included to make life easier for LUKS users)
  mountType := ftLinux;
  for i:=0 to (filesToMount.count - 1) do
    begin
    if not(OTFEFreeOTFE.IsLUKSVolume(filesToMount[i])) then
      begin
      mountType := defaultType;
      break;
      end;
    end;

  MountFiles(mountType, filesToMount, FALSE);

end;


procedure TfrmFreeOTFEMain.WMDeviceChange(var Msg : TMessage);
begin
  RefreshDrives();

end;


// Function required for close to system tray icon
procedure TfrmFreeOTFEMain.WMQueryEndSession(var msg: TWMQueryEndSession);
begin
  // Default to allowing shutdown
  msg.Result := 1;
  EndSessionFlag := (msg.Result = 1);
  inherited;
  EndSessionFlag := (msg.Result = 1);
  
end;


// Function required for close to system tray icon
procedure TfrmFreeOTFEMain.WMEndSession(var msg: TWMEndSession);
begin
  EndSessionFlag := msg.EndSession;

end;


procedure TfrmFreeOTFEMain.DriveProperties();
var
  propertiesDlg: TfrmFreeOTFEVolProperties;
  i: integer;
begin
  for i:=0 to (lvDrives.items.count-1) do
    begin
    if lvDrives.Items[i].Selected then
      begin
      propertiesDlg:= TfrmFreeOTFEVolProperties.Create(self);
      try
        propertiesDlg.DriveLetter := GetDriveLetterFromLVItem(lvDrives.Items[i]);
        propertiesDlg.OTFEFreeOTFE := OTFEFreeOTFE;
        propertiesDlg.ShowModal();
      finally
        propertiesDlg.Free();
      end;

      end;
    end;

end;


// If "isEmergency" is TRUE, the user will *not* be informed of any drives
// which couldn't be dismounted
function TfrmFreeOTFEMain.DismountAll(isEmergency: boolean = FALSE): boolean;
var
  drivesRemaining: string;
  allOK: boolean;
  initialDrives: string;
  i: integer;
begin
  allOK := TRUE;

  // Change CWD to anywhere other than a mounted drive
  ChangeCWDToSafeDir();

  // Launch any pre-dismount executable
  initialDrives := OTFEFreeOTFE.DrivesMounted;
  for i:=1 to length(initialDrives) do
    begin
    AutoRunExecute(arPreDismount, initialDrives[i], isEmergency);
    end;

  OTFEFreeOTFE.DismountAll(isEmergency);

  // If it wasn't an emergency dismount, and drives are still mounted, report.
  drivesRemaining := OTFEFreeOTFE.DrivesMounted();

  for i:=1 to length(initialDrives) do
    begin
    // If the drive is no longer mounted, run any post-dismount executable
    if (Pos(initialDrives[i], drivesRemaining) <= 0) then
      begin
      AutoRunExecute(arPostDismount, initialDrives[i], isEmergency);
      end;
    end;

  if (drivesRemaining<>'') then
    begin
    if not(isEmergency) then
      begin
      allOK := FALSE;
      RefreshDrives();
      ReportDrivesNotDismounted(drivesRemaining, FALSE);
      end
    else
      begin
      // Just give it another go... Best we can do.
      OTFEFreeOTFE.DismountAll(isEmergency);
      end;
    end;

  RefreshDrives();

  Result := allOK;
end;


function TfrmFreeOTFEMain.DismountSelected(): boolean;
var
  i: integer;
  drivesRemaining: string;
  toDismount: string;
  allOK: boolean;
begin
  drivesRemaining := '';

  // First we build up a list of drives to dismount, then we dismount them.
  // This is done since we can't just run through the lvDrives looking for
  // selected items, as they're getting removed while we walk though the list!

  for i:=0 to (lvDrives.items.count-1) do
    begin
    if lvDrives.Items[i].Selected then
      begin
      toDismount := toDismount + GetDriveLetterFromLVItem(lvDrives.Items[i]);
      end;
    end;

  allOK := DismountDrives(toDismount, FALSE);

  Result := allOK;
end;


// Dismount the drives specified
// This procedure *will* report drives which couldn't be mounted - regardless
// of "isEmergency"
function TfrmFreeOTFEMain.DismountDrives(dismountDrives: string; isEmergency: boolean): boolean;
var
  i: integer;
  j: integer;
  subVols: string;
  tmpDrv: char;
  drivesRemaining: string;
  allOK: boolean;
begin
  allOK := TRUE;
  drivesRemaining := '';

  // Change CWD to anywhere other than a mounted drive
  ChangeCWDToSafeDir();

  // Skip processing if no drives to dismount - otherwise it'll just flicker
  // the display
  if (dismountDrives <> '') then
    begin
    // Ensure that none of the drives to be dismounted contain one of the other
    // mounted drives
    // Although FreeOTFE wouldn't be able to dismount such a drive (it would
    // the mounted volume stored on it would have an open filehandles, so
    // preventing the dismount), it's clearly better to warn the user in a more
    // meaningful way than just "can't do it - files open"
    for i:=1 to length(dismountDrives) do
      begin
      tmpDrv := dismountDrives[i];

      subVols := OTFEFreeOTFE.VolsMountedOnDrive(tmpDrv);
      for j:=1 to length(subVols) do
        begin
        if (Pos(subVols[j], dismountDrives) = 0) then
          begin
          // At least one of the currently mounted drives is stored on one of
          // the drives to be dismounted - and we're not dismounting that drive
          SDUMessageDlg(
                        Format(_('The volume currently mounted as %s: must be dismounted before %s: can be dismounted'), [subVols[j], tmpDrv]),
                        mtError
                       );
          allOK := FALSE;
          end;
        end;
      end;

    if allOK then
      begin
      // Sort out dismount order, in case one drive nested within another
      dismountDrives := OTFEFreeOTFE.DismountOrder(dismountDrives);


      for i:=1 to length(dismountDrives) do
        begin
        tmpDrv := dismountDrives[i];

        // Pre-dismount...
        AutoRunExecute(arPreDismount, tmpDrv, isEmergency);

        if OTFEFreeOTFE.Dismount(tmpDrv, isEmergency) then
          begin
          // Dismount OK, execute post-dismount...
          AutoRunExecute(arPostDismount, tmpDrv, isEmergency);
          end
        else
          begin
          drivesRemaining := drivesRemaining + tmpDrv;
          allOK := FALSE;
          end;

        end;

      if (drivesRemaining<>'') then
        begin
        RefreshDrives();
        ReportDrivesNotDismounted(drivesRemaining, isEmergency);
        end;

      RefreshDrives();
      end;
    end;

  Result := allOK;
end;


// Warn the user that some drives remain mounted, and if the dismount attempted
// wasn't an emergency dismount, then prompt the user if they want to attempt
// an emergency dismount
procedure TfrmFreeOTFEMain.ReportDrivesNotDismounted(drivesRemaining: string; isEmergency: boolean);
var
  msg: string;
begin
  msg := SDUPluralMsg(
                      length(drivesRemaining),
                      Format(_('Unable to dismount drive: %s'), [PrettyPrintDriveLetters(drivesRemaining)]),
                      Format(_('Unable to dismount drives: %s'), [PrettyPrintDriveLetters(drivesRemaining)])
                     );

  // If the dismount attempted was a non-emergency dismount; prompt user if
  // they want to attempt an emergency dismount
  if not(isEmergency) then
    begin
    msg := msg+SDUCRLF+
           SDUCRLF+
           SDUPluralMsg(
                        length(drivesRemaining),
                        _('Do you wish to force a dismount on this drive?'),
                        _('Do you wish to force a dismount on these drives?')
                       );

    if (SDUMessageDlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes)then
      begin
      if (SDUMessageDlg(
                     _('Warning: Emergency dismounts are not recommended')+SDUCRLF+
                     SDUCRLF+
                     _('Are you sure you wish to proceed?'),
                     mtWarning,
                     [mbYes,mbNo],
                     0
                    ) = mrYes) then
        begin
        DismountDrives(drivesRemaining, TRUE);
        end;

      end;
    end
  else
    begin
    // Dismount reporting on *was* an emergency dismount; just report remaining
    // drives still mounted
    SDUMessageDlg(msg, mtInformation, [mbOK], 0);
    end;

end;



procedure TfrmFreeOTFEMain.lvDrivesClick(Sender: TObject);
begin
  EnableDisableControls();

end;

procedure TfrmFreeOTFEMain.EnableDisableControls();
var
  drivesSelected: boolean;
  drivesMounted: boolean;
begin
  SDUEnableControl(actPKCS11TokenManagement, Settings.OptPKCS11Enable);

  // The FreeOTFE object may not be active...
  actFreeOTFENew.Enabled            := OTFEFreeOTFE.Active;
  actFreeOTFEMountFile.Enabled      := OTFEFreeOTFE.Active;
  actFreeOTFEMountPartition.Enabled := (OTFEFreeOTFE.Active and OTFEFreeOTFE.CanMountDevice());
  // Linux menuitem completely disabled if not active...
  miLinuxVolume.Enabled             := OTFEFreeOTFE.Active;
  actLinuxNew.Enabled               := miLinuxVolume.Enabled;
  actLinuxMountFile.Enabled         := miLinuxVolume.Enabled;
  actLinuxMountPartition.Enabled    := (miLinuxVolume.Enabled and OTFEFreeOTFE.CanMountDevice());

  miChangePassword.Enabled := OTFEFreeOTFE.Active;
  miCreateKeyfile.Enabled  := OTFEFreeOTFE.Active;
  miCDB.Enabled            := OTFEFreeOTFE.Active;

  // Flags used later
  drivesSelected := (lvDrives.selcount > 0);
  drivesMounted  := (lvDrives.Items.count > 0);


  // Actions & menuitems to be enabled/disabled, depending on whether a drive
  // is selected
  actDismount.enabled   := drivesSelected;
  actProperties.enabled := drivesSelected;

  miFormat.enabled                  := drivesSelected;
  miPopupFormat.enabled             := drivesSelected;
  actOverwriteFreeSpace.enabled     := drivesSelected;  // Note: Implies FreeOTFE drivers are running
  actOverwriteEntireDrive.enabled   := drivesSelected;  // Note: Implies FreeOTFE drivers are running


  // Action item to be enabled/disabled, as long as one or more drives are
  // mounted
  actDismountAll.enabled  := drivesMounted;

  // Driver handling...
  actTogglePortableMode.Checked := (CountPortableDrivers > 0);
  actTogglePortableMode.Enabled := (
                                    OTFEFreeOTFE.CanUserManageDrivers() or
                                    // If we're on Vista, always allow the
                                    // toggle portable mode option; the
                                    // user can escalate UAC if needed
                                    SDUOSVistaOrLater()
                                   );
  // If the portable mode control is enabled, but we don't know how many
  // drivers there are in portable mode, presumably we're running under
  // Vista without admin access - in which case this control just toggles the
  // portable mode status - and DOESN'T turn it on/off
  if (
      actTogglePortableMode.Enabled and
      (CountPortableDrivers < 0)
     ) then
    begin
    actTogglePortableMode.Caption := _('Toggle portable mode drivers');
    end
  else
    begin
    actTogglePortableMode.Caption := _('Use portable mode drivers');

    // Ensure NO ICON FOR PORTABLE MODE DRIVERS if the user is admin; it shows
    // a checkbox instead, depending on whether the drivers are running or not
    miPortableModeDrivers.ImageIndex := -1;
    end;


  // Because the copy system "dumbly" copies the dir *this* executable is in,
  // plus anything below it, we disable the "Copy FreeOTFE to..." menuitem if
  // *this* application is running from a root dir.
  // >3 because the root'll be "X:\"; 3 chars long
  SDUEnableControl(
                   actInstallOnUSBDrive,
                   (length(ExtractFilePath(ParamStr(0))) > 3)
                  );

  // Misc display related...
  if drivesMounted then
    begin
    SDUSystemTrayIcon1.Icon := IconMounted;
    end
  else
    begin
    SDUSystemTrayIcon1.Icon := IconUnmounted;
    end;

  ToolBar1.Visible := Settings.OptDisplayToolbar;
  StatusBar1.Visible := Settings.OptDisplayStatusbar;
  SetStatusBarTextNormal();

end;

procedure TfrmFreeOTFEMain.SetStatusBarTextNormal();
var
  drvLetter: char;
  freeSpace: int64;
  totalSpace: int64;
  statusText: string;
  i: integer;
begin
  statusText := '';

  // Update status bar text, if visible
  if StatusBar1.Visible then
    begin
    statusText := '';
    if not(OTFEFreeOTFE.Active) then
      begin
      statusText := _('FreeOTFE main driver not connected.');
      end
    else if (lvDrives.SelCount = 0) then
      begin
      statusText := SDUPluralMsg(
                                 lvDrives.Items.Count,
                                 Format(_('%d drive mounted.'), [lvDrives.Items.Count]),
                                 Format(_('%d drives mounted.'), [lvDrives.Items.Count])
                                );
      end
    else if (lvDrives.SelCount > 0) then
      begin
      if (lvDrives.SelCount = 1) then
        begin
        for i:=0 to (lvDrives.items.count-1) do
          begin
          if lvDrives.Items[i].Selected then
            begin
            drvLetter := GetDriveLetterFromLVItem(lvDrives.Items[i]);
            freeSpace := DiskFree(Ord(drvLetter) - 64);
            totalSpace := DiskSize(Ord(drvLetter) - 64);

            if (
                (freeSpace > -1) and
                (totalSpace > -1)
               ) then
              begin
              statusText := Format(
                                   _('%s: Free Space: %s; Total size: %s'),
                                   [
                                    drvLetter,
                                    SDUFormatUnits(
                                                   freeSpace,
                                                   UNITS_BYTES_DENOMINATINON,
                                                   UNITS_BYTES_MULTIPLIER,
                                                   1
                                                  ),
                                    SDUFormatUnits(
                                                   totalSpace,
                                                   UNITS_BYTES_DENOMINATINON,
                                                   UNITS_BYTES_MULTIPLIER,
                                                   1
                                                  )
                                    ]
                                   );
              end;

            break;
            end;
          end;
        end;

      if (statusText = '') then
        begin
        statusText := SDUPluralMsg(
                                   lvDrives.SelCount,
                                   Format(_('%d drive selected.'), [lvDrives.SelCount]),
                                   Format(_('%d drives selected.'), [lvDrives.SelCount])
                                  );
        end;

      end;

    end;

  SetStatusBarText(statusText);
end;

procedure TfrmFreeOTFEMain.SetStatusBarText(statusText: string);
begin
  StatusBar1.SimpleText := statusText;
end;

function TfrmFreeOTFEMain.GetDriveLetterFromLVItem(listItem: TListItem): char;
var
  tmpDrv: string;
begin
  // Trim the padding whitespace off the drive letter + colon
  tmpDrv := listItem.Caption;
  tmpDrv := TrimLeft(tmpDrv);

  // The first letter of the item's caption is the drive letter
  Result := tmpDrv[1];

end;

procedure TfrmFreeOTFEMain.lvDrivesDblClick(Sender: TObject);
var
  driveLetter: char;
begin
  if (lvDrives.selcount > 0) then
    begin
    driveLetter := GetDriveLetterFromLVItem(lvDrives.selected);
    ExploreDrive(driveLetter);
    end;

end;

// Launch autorun executable on specified drive
procedure TfrmFreeOTFEMain.AutoRunExecute(autorun: TAutorunType; driveLetter: char; isEmergency: boolean);
var
  exeFullCmdLine: string;
  launchOK: boolean;
  splitCmdLine: TStringList;
  exeOnly: string;
begin
  // Sanity...
  if (driveLetter = #0) then
    begin
    exit;
    end;

  exeFullCmdLine := '';
  
  case autorun of

    arPostMount:
      begin
      exeFullCmdLine := Settings.OptPostMountExe;
      end;

    arPreDismount:
      begin
      // We don't bother with predismount in case of emergency
      if not(isEmergency) then
        begin
        exeFullCmdLine := Settings.OptPreDismountExe;
        end;
      end;

    arPostDismount:
      begin
      exeFullCmdLine := Settings.OptPostDismountExe;
      end;

    else
      begin
      if not(isEmergency) then
        begin
        SDUMessageDlg(_('Unknown autorun type?!'), mtError);
        end;
      end;

    end;

  if (exeFullCmdLine <> '') then
    begin
    // Split up, in case user is using a commandline with spaces in the
    // executable path
    splitCmdLine:= TStringList.Create();
    try
      splitCmdLine.QuoteChar := '"';
      splitCmdLine.Delimiter := ' ';
      splitCmdLine.DelimitedText := trim(exeFullCmdLine);

      // Relative path with mounted drive letter
      if (
          (autorun = arPostMount) or
          (autorun = arPreDismount)
         ) then
        begin
        splitCmdLine[0] := driveLetter + ':' + splitCmdLine[0];
        end;

      exeOnly := splitCmdLine[0];
      
      // Recombine to produce new commandline
      exeFullCmdLine := splitCmdLine.DelimitedText;

    finally
      splitCmdLine.Free();
    end;

    // Perform substitution, if needed
    exeFullCmdLine := StringReplace(
                                    exeFullCmdLine,
                                    AUTORUN_SUBSTITUTE_DRIVE,
                                    driveLetter,
                                    [rfReplaceAll]
                                   );

    // NOTE: THIS MUST BE UPDATED IF CMDLINE IS TO SUPPORT COMMAND LINE
    //       PARAMETERS!
    if not(FileExists(exeOnly)) then
      begin
      if (
          not(isEmergency) and
          Settings.OptPrePostExeWarn
         ) then
        begin
        SDUMessageDlg(
                      Format(_('Unable to locate %s executable:'), [AUTORUN_TITLE[autorun]])+SDUCRLF+
                      SDUCRLF+
                      exeOnly,
                      mtWarning
                     );
        end;
      end
    else
      begin
      if (autorun = arPreDismount) then
        begin
        // Launch and block until terminated...
        launchOK := (SDUWinExecAndWait32(exeFullCmdLine, SW_SHOW, driveLetter+':\') <> $FFFFFFFF);
        end
      else
        begin
        // Fire and forget...
        launchOK := (WinExec(PChar(exeFullCmdLine), SW_RESTORE) >= 31)
        end;

      if not(launchOK) then
        begin
        if not(isEmergency) then
          begin
          SDUMessageDlg(
                        Format(_('Error running %s executable:'), [AUTORUN_TITLE[autorun]])+SDUCRLF+
                        SDUCRLF+
                        exeFullCmdLine,
                        mtError
                       );
          end;
        end;
      end;
    end;

end;


procedure TfrmFreeOTFEMain.ExploreDrive(driveLetter: char);
var
  explorerCommandLine: string;
begin
  if (driveLetter <> #0) then
    begin
    explorerCommandLine := 'explorer '+driveLetter+':\';

    if (WinExec(PChar(explorerCommandLine), SW_RESTORE))<31 then
      begin
      SDUMessageDlg(_('Error running Explorer'), mtError, [mbOK], 0);
      end;
    end;

end;

procedure TfrmFreeOTFEMain.DisplayDriverControlDlg();
var
  UACEscalateAttempted: boolean;
begin
  UACEscalateAttempted := FALSE;

  DeactivateFreeOTFEComponent();
  try
    try
      // This is surrounded by a try...finally as it may throw an exception if
      // the user doesn't have sufficient privs to do this
      OTFEFreeOTFE.ShowDriverControlDlg();

      // Send out a message to any other running instances of FreeOTFE to
      // refresh; the drivers may have changed.
      // Note that if we had to UAC escalate (see exception below), the UAC
      // escalated process will send out this windows message
{$IFDEF VER185}
      //SendMessage(HWND_BROADCAST, GLOBAL_VAR_WM_FREEOTFE_REFRESH, 0, 0);
      PostMessage(HWND_BROADCAST, GLOBAL_VAR_WM_FREEOTFE_REFRESH, 0, 0);
{$ELSE}
      SDUPostMessageExistingApp(GLOBAL_VAR_WM_FREEOTFE_REFRESH, 0, 0);
{$ENDIF}
    except
      on EFreeOTFENeedAdminPrivs do
        begin
        UACEscalateForDriverInstallation();
        UACEscalateAttempted := TRUE;
        end;
    end;

  finally
    // Note: We supress any messages that may be the result of failing to
    //       activate the OTFEFreeOTFE componentactivating the if we had to
    //       UAC escalate.
    //       In that situation, the UAC escalated process will sent out a
    //       refresh message when it's done. 
    ActivateFreeOTFEComponent(UACEscalateAttempted);

    EnableDisableControls();
  end;

end;

procedure TfrmFreeOTFEMain.actDriversExecute(Sender: TObject);
begin
  DisplayDriverControlDlg();
end;

function TfrmFreeOTFEMain.ActivateFreeOTFEComponent(suppressMsgs: boolean): boolean;
var
  obsoleteDriver: boolean;
begin
  obsoleteDriver:= FALSE;
  try
    OTFEFreeOTFE.Active := TRUE;
  except
    on EFreeOTFEObsoleteDriver do
      begin
      obsoleteDriver := TRUE;
      end;

  else
    // We should only get to here if the FreeOTFE driver isn't both
    // installed & started

  end;


  if (
      not(suppressMsgs) and
      not(OTFEFreeOTFE.Active) and
      not(ShuttingDownFlag)  // Don't complain to user is we're about to exit!
     ) then
    begin
    if (obsoleteDriver) then
      begin
      SDUMessageDlg(
                 _('In order to use this software, you must first upgrade your FreeOTFE drivers to a later version.')+SDUCRLF+
                 SDUCRLF+
                 _('If you have just upgraded your copy of FreeOTFE from a previous version, please ensure that you have followed the upgrade instructions that came with it, and have rebooted if necessary.'),
                 mtError,
                 [mbOK],
                 0
                );
      end
    else
      begin
      SDUMessageDlg(
                 _('Unable to connect to the main FreeOTFE driver.')+SDUCRLF+
                 SDUCRLF+
                 _('Please ensure that the main "FreeOTFE" driver is installed and started.')+SDUCRLF+
                 SDUCRLF+
                 _('If you have only just installed FreeOTFE, please reboot and try again.'),
                 mtError,
                 [mbOK],
                 0
                );
      end;

    // Note that we don't terminate here; the user may still use the driver
    // control functionality to install and/or start the FreeOTFE driver
    end;

  // Old driver warnings
  if OTFEFreeOTFE.Active then
    begin
    if (OTFEFreeOTFE.Version() < FREEOTFE_ID_v03_00_0000) then
      begin
      SDUMessageDlg(
                 Format(_('The main FreeOTFE driver installed on this computer dates back to FreeOTFE %s'), [OTFEFreeOTFE.VersionStr()])+SDUCRLF+
                 SDUCRLF+
                 _('It is highly recommended that you upgrade your FreeOTFE drivers to v3.00 or later as soon as possible, in order to allow the use of LRW and XTS based volumes.')+SDUCRLF+
                 SDUCRLF+
                 _('See documentation (installation section) for instructions on how to do this.'),
                 mtWarning,
                 [mbOK],
                 0
                );
      end
    else if (OTFEFreeOTFE.Version() < FREEOTFE_ID_v04_30_0000) then
      begin
      SDUMessageDlg(
                 Format(_('The main FreeOTFE driver installed on this computer dates back to FreeOTFE %s'), [OTFEFreeOTFE.VersionStr()])+SDUCRLF+
                 SDUCRLF+
                 _('It is highly recommended that you upgrade your FreeOTFE drivers to those included in v4.30 or later as soon as possible, due to improvements in the main driver.')+SDUCRLF+
                 SDUCRLF+
                 _('See documentation (installation section) for instructions on how to do this.'),
                 mtWarning,
                 [mbOK],
                 0
                );
      end;
    end;

  // Let Windows know whether we accept dropped files or not
  DragAcceptFiles(self.Handle, OTFEFreeOTFE.Active);

  Result := OTFEFreeOTFE.Active;
end;



procedure TfrmFreeOTFEMain.DeactivateFreeOTFEComponent();
begin
  OTFEFreeOTFE.Active := FALSE;

  // Let Windows know we accept dropped files or not
  DragAcceptFiles(self.Handle, OTFEFreeOTFE.Active);

end;


// The array passed in is zero-indexed; populate elements zero to "bytesRequired"
procedure TfrmFreeOTFEMain.GenerateOverwriteData(Sender: TObject; passNumber: integer; bytesRequired: cardinal; var outputBlock: TShredBlock);
var
  i: integer;
  tempArraySize: cardinal;
  blocksizeBytes: cardinal;
  plaintext: string;
  cyphertext: string;
  IV: string;
  localIV: int64;
  sectorID: LARGE_INTEGER;
begin
  // Generate an array of random data containing "bytesRequired" bytes of data,
  // plus additional random data to pad out to the nearest multiple of the
  // cypher's blocksize bits
  // Cater for if the blocksize was -ve or zero
  if (TempCypherDetails.BlockSize < 1) then
    begin
    blocksizeBytes := 1;
    end
  else
    begin
    blocksizeBytes := (TempCypherDetails.BlockSize div 8);
    end;
  tempArraySize := bytesRequired + (blocksizeBytes - (bytesRequired mod blocksizeBytes));

  plaintext := '';
  for i:=1 to tempArraySize do
    begin
    plaintext := plaintext + char(random(256));
    end;


  inc(TempCypherEncBlockNo);

  // Adjust the IV so that this block of encrypted pseudorandom data should be
  // reasonably unique
  IV := '';
  if (TempCypherDetails.BlockSize > 0) then
    begin
    IV := StringOfChar(#0, (TempCypherDetails.BlockSize div 8));

    localIV := TempCypherEncBlockNo;

    for i:=1 to min(sizeof(localIV), length(IV)) do
      begin
      IV[i] := char((localIV AND $FF));
      localIV := localIV shr 8;
      end;

    end;

  // Adjust the sectorID so that this block of encrypted pseudorandom data
  // should be reasonably unique
  sectorID.QuadPart := TempCypherEncBlockNo;

  // Encrypt the pseudorandom data generated
  if not(OTFEFreeOTFE.EncryptSectorData(
                                  TempCypherDriver,
                                  TempCypherGUID,
                                  sectorID,
                                  FREEOTFE_v1_DUMMY_SECTOR_SIZE,
                                  TempCypherKey,
                                  IV,
                                  plaintext,
                                  cyphertext
                                 )) then
    begin
    SDUMessageDlg(
               _('Unable to encrypt pseudorandom data before using for overwrite buffer?!'),
               mtWarning,
               [mbOK],
               0
              );
    end;

  // Copy the encrypted data into the outputBlock
  for i:=0 to (bytesRequired-1) do
    begin
    outputBlock[i] := byte(cyphertext[i+1]);
    end;

end;


function TfrmFreeOTFEMain.PortableModeSet(setTo: TPortableModeAction; suppressMsgs: boolean): boolean;
var
  retval: boolean;
begin
  retval := FALSE;

  if not(OTFEFreeOTFE.CanUserManageDrivers()) then
    begin
    // On Vista, escalate UAC
    if SDUOSVistaOrLater() then
      begin
      UACEscalateForPortableMode(setTo, suppressMsgs);
      end
    else
      begin
      // On pre-Vista, just let user know they can't do it
      if not(suppressMsgs) then
        begin
        SDUMessageDlg(
                      TEXT_NEED_ADMIN,
                      mtWarning,
                      [mbOK],
                      0
                     );
        end;
      end;

    end
  else
    begin
    case setTo of
      pmaStart:
        begin
        retval := _PortableModeStart(suppressMsgs);
        end;

      pmaStop:
        begin
        retval := _PortableModeStop(suppressMsgs);
        end;

      pmaToggle:
        begin
        retval := _PortableModeToggle(suppressMsgs);
        end;

    end;

    // In case we UAC escalated (i.e. ran a separate process to handle the
    // drivers), we send out a message to any other running instances of
    // FreeOTFE to refresh
{$IFDEF VER185}
      //SendMessage(HWND_BROADCAST, GLOBAL_VAR_WM_FREEOTFE_REFRESH, 0, 0);
      PostMessage(HWND_BROADCAST, GLOBAL_VAR_WM_FREEOTFE_REFRESH, 0, 0);
{$ELSE}
      SDUPostMessageExistingApp(GLOBAL_VAR_WM_FREEOTFE_REFRESH, 0, 0);
{$ENDIF}
    end;

  Result := retval;
end;

procedure TfrmFreeOTFEMain.GetAllDriversUnderCWD(driverFilenames: TStringList);
const
  // Subdirs which should be searched for drivers
  DRIVERS_SUBDIR_32_BIT = '\x86';
  DRIVERS_SUBDIR_64_BIT = '\amd64';
var
  fileIterator: TSDUFileIterator;
  filename: string;
  driversDir: string;
begin
  // Compile a list of drivers in the CWD
  fileIterator:= TSDUFileIterator.Create(nil);
  try
    driversDir := ExtractFilePath(Application.ExeName);
    if SDUOS64bit() then
      begin
      driversDir := driversDir + DRIVERS_SUBDIR_64_BIT;
      end
    else
      begin
      driversDir := driversDir + DRIVERS_SUBDIR_32_BIT;
      end;

    fileIterator.Directory := driversDir;
    fileIterator.FileMask := '*.sys';
    fileIterator.RecurseSubDirs := FALSE;
    fileIterator.OmitStartDirPrefix := FALSE;
    fileIterator.IncludeDirNames := FALSE;

    fileIterator.Reset();
    filename := fileIterator.Next();
    while (filename<>'') do
      begin
      driverFilenames.Add(filename);
      filename := fileIterator.Next();
      end;

  finally
    fileIterator.Free();
  end;
end;

function TfrmFreeOTFEMain._PortableModeStart(suppressMsgs: boolean): boolean;
var
  driverFilenames: TStringList;
  allOK: boolean;
begin
  allOK:= FALSE;

  driverFilenames:= TStringList.Create();
  try
    GetAllDriversUnderCWD(driverFilenames);

    if (driverFilenames.count<1) then
      begin
      if not(suppressMsgs) then
        begin
        SDUMessageDlg(
                   _('Unable to locate any portable FreeOTFE drivers.')+SDUCRLF+
                   SDUCRLF+
                   _('Please ensure that the a copy of the FreeOTFE drivers (".sys" files) you wish to use are located in the correct directory.'),
                   mtWarning,
                   [mbOK],
                   0
                  );
        end;
      end
    else
      begin
      DeactivateFreeOTFEComponent();
      if OTFEFreeOTFE.PortableStart(driverFilenames, not(suppressMsgs)) then
        begin
// Message commented out - it's pointless as user will know anyway because
// either:
//   a) They started it, or
//   b) It's started automatically on FreeOTFE startup - in which case, it's
//      just annoying
//        if not(suppressMsgs) then
//          begin
//          SDUMessageDlg('Portable mode drivers installed and started.', mtInformation, [mbOK], 0);
//          end;
        allOK:= TRUE;
        end
      else
        begin
        if not(suppressMsgs) then
          begin
          SDUMessageDlg(
                     _('One or more of your portable FreeOTFE drivers could not be installed/started.')+SDUCRLF+
                     SDUCRLF+
                     TEXT_NEED_ADMIN+SDUCRLF+
                     SDUCRLF+
                     _('Please select "File | Drivers..." to check which drivers are currently operating.'),
                     mtWarning,
                     [mbOK],
                     0
                    );
          end;
        end;

      end;

  finally
    driverFilenames.Free();
    ActivateFreeOTFEComponent(suppressMsgs);
  end;

  Result := allOK;
end;

function TfrmFreeOTFEMain._PortableModeStop(suppressMsgs: boolean): boolean;
var
  allOK: boolean;
  stopOK: boolean;
begin
  allOK := FALSE;

  // Note that if the component was *not* active, then we can shutdown all
  // portable mode drivers; if we aren't active, this implies the main driver
  // isn't installed/running - in which case we don't need the user to confirm
  // as no drives can be mounted
  stopOK := TRUE;
  if OTFEFreeOTFE.Active then
    begin
    if (OTFEFreeOTFE.CountDrivesMounted() > 0) then
      begin
      if suppressMsgs then
        begin
        stopOK := FALSE;
        end
      else
        begin
        stopOK := (SDUMessageDlg(
                               _('You have one or more volumes mounted.')+SDUCRLF+
                               SDUCRLF+
                               _('If any of the currently mounted volumes makes use of any of the FreeOTFE drivers which are currently in portable mode, stopping portable mode is not advisable.')+SDUCRLF+
                               SDUCRLF+
                               _('It is recommended that you dismount all volumes before stopping portable mode.')+SDUCRLF+
                               SDUCRLF+
                               _('Do you wish to continue stopping portable mode?'),
                               mtWarning,
                               [mbYes, mbNo],
                               0
                              ) = mrYes);
        end;
      end;
    end;
    

  if stopOK then
    begin
    DeactivateFreeOTFEComponent();
    if OTFEFreeOTFE.PortableStop() then
      begin
      // No point in informing user; they would have been prompted if they
      // wanted to do this, and they can tell they've stopped as the
      // application will just exit; only popping up a messagebox if there's a
      // problem
      if not(ShuttingDownFlag) then
        begin
        if not(suppressMsgs) then
          begin
          SDUMessageDlg(_('Portable mode drivers stopped and uninstalled.'), mtInformation, [mbOK], 0);
          end;
        end;

      allOK := TRUE;
      end
    else
      begin
      if not(suppressMsgs) then
        begin
        SDUMessageDlg(
                   _('One or more of your portable FreeOTFE drivers could not be stopped/uninstalled.')+SDUCRLF+
                   SDUCRLF+
                   TEXT_NEED_ADMIN+SDUCRLF+
                   SDUCRLF+
                   _('Please select "File | Drivers..." to check which drivers are currently operating.'),
                   mtWarning,
                   [mbOK],
                   0
                  );
        end;
      end;

    ActivateFreeOTFEComponent(suppressMsgs);
    end;

  Result := allOK;
end;

function TfrmFreeOTFEMain._PortableModeToggle(suppressMsgs: boolean): boolean;
var
  retval: boolean;
  cntPortable: integer;
begin
  retval := FALSE;

  cntPortable := OTFEFreeOTFE.DriversInPortableMode();

  if (cntPortable < 0) then
    begin
    // We *should* be authorised to do this by the time we get here...
    // Do nothing; retval already set to FALSE
    end
  else if (cntPortable > 0) then
    begin
    retval := PortableModeSet(pmaStop, suppressMsgs);
    end
  else
    begin
    retval := PortableModeSet(pmaStart, suppressMsgs);
    end;

  Result := retval;
end;


procedure TfrmFreeOTFEMain.miCDBBackupClick(Sender: TObject);
var
  dlg: TfrmFreeOTFECDBBackupRestore;
begin
  dlg:= TfrmFreeOTFECDBBackupRestore.Create(self);
  try
    dlg.OTFEFreeOTFE := OTFEFreeOTFE;
    dlg.DlgType := opBackup;
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;

procedure TfrmFreeOTFEMain.miCDBRestoreClick(Sender: TObject);
var
  dlg: TfrmFreeOTFECDBBackupRestore;
begin
  dlg:= TfrmFreeOTFECDBBackupRestore.Create(self);
  try
    dlg.OTFEFreeOTFE := OTFEFreeOTFE;
    dlg.DlgType := opRestore;
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;


procedure TfrmFreeOTFEMain.miCreateKeyfileClick(Sender: TObject);
begin
  OTFEFreeOTFE.WizardCreateKeyfile();
end;

procedure TfrmFreeOTFEMain.miChangePasswordClick(
  Sender: TObject);
begin
  OTFEFreeOTFE.WizardChangePassword();
end;

procedure TfrmFreeOTFEMain.miCDBPlaintextDumpClick(Sender: TObject);
begin
  DumpDetailsToFile(FALSE);

end;



procedure TfrmFreeOTFEMain.miLUKSDumpClick(Sender: TObject);
begin
  DumpDetailsToFile(TRUE);

end;



procedure TfrmFreeOTFEMain.DumpDetailsToFile(LUKSDump: boolean);
var
  dlg: TfrmFreeOTFECDBDump;
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    dlg:= TfrmFreeOTFECDBDump.Create(self);
    try
      dlg.LUKSDump := LUKSDump;
      dlg.OTFEFreeOTFE := OTFEFreeOTFE;
      dlg.ShowModal();
    finally
      dlg.Free();
    end;

    end;

end;


procedure TfrmFreeOTFEMain.actFreeOTFENewExecute(Sender: TObject);
begin
  if OTFEFreeOTFE.CreateFreeOTFEVolumeWizard() then
    begin
    SDUMessageDlg(
               _('FreeOTFE volume created successfully.')+SDUCRLF+
               SDUCRLF+
               _('Please mount, format and overwrite this volume''s free space before use.'),
               mtInformation, [mbOK], 0);
    end
  else
    begin
    if (OTFEFreeOTFE.LastErrorCode <> OTFE_ERR_USER_CANCEL) then
      begin
      SDUMessageDlg(_('FreeOTFE volume could not be created'), mtError);
      end;
    end;

end;

procedure TfrmFreeOTFEMain.actInstallOnUSBDriveExecute(Sender: TObject);
var
  dlg: TfrmInstallOnUSBDrive;
begin
  dlg:= TfrmInstallOnUSBDrive.Create(nil);
  try
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;

procedure TfrmFreeOTFEMain.actFreeOTFEMountFileExecute(Sender: TObject);
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    SDUOpenSaveDialogSetup(OpenDialog, '');

    OpenDialog.Filter     := FILE_FILTER_FLT_VOLUMES;
    OpenDialog.DefaultExt := FILE_FILTER_DFLT_VOLUMES;

    if OpenDialog.Execute() then
      begin
      MountFilesDetectLUKS(
                           TStringList(OpenDialog.Files),
                           (ofReadOnly in OpenDialog.Options),
                           ftFreeOTFE
                          );
      end;
    end;

end;

procedure TfrmFreeOTFEMain.actFreeOTFEMountPartitionExecute(
  Sender: TObject);
var
  selectedPartition: string;
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    selectedPartition := OTFEFreeOTFE.SelectPartition();

    if (selectedPartition <> '') then
      begin
      MountFiles(ftFreeOTFE, selectedPartition, FALSE);
      end;
    end;

end;

procedure TfrmFreeOTFEMain.actDismountExecute(Sender: TObject);
begin
  DismountSelected();

end;

procedure TfrmFreeOTFEMain.actDismountAllExecute(Sender: TObject);
begin
  DismountAll();

end;

procedure TfrmFreeOTFEMain.actLinuxNewExecute(Sender: TObject);
begin
  if OTFEFreeOTFE.CreateLinuxVolumeWizard() then
    begin
    SDUMessageDlg(
               _('Linux volume created successfully.')+SDUCRLF+
               SDUCRLF+
               _('Don''t forget to mount and format this volume before use.'),
               mtInformation);
    end
  else
    begin
    if (OTFEFreeOTFE.LastErrorCode <> OTFE_ERR_USER_CANCEL) then
      begin
      SDUMessageDlg(_('Linux volume could not be created'), mtError);
      end;
    end;

end;

procedure TfrmFreeOTFEMain.actListHashesExecute(Sender: TObject);
var
  dlg: TfrmGridReport_Hash;
begin
  dlg := TfrmGridReport_Hash.Create(self);
  try
    dlg.OTFEFreeOTFE := OTFEFreeOTFE;
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;

procedure TfrmFreeOTFEMain.actListCyphersExecute(Sender: TObject);
var
  dlg: TfrmGridReport_Cypher;
begin
  dlg := TfrmGridReport_Cypher.Create(self);
  try
    dlg.OTFEFreeOTFE := OTFEFreeOTFE;
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;

procedure TfrmFreeOTFEMain.actLinuxMountFileExecute(Sender: TObject);
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    OpenDialog.Filter     := FILE_FILTER_FLT_VOLUMES;
    OpenDialog.DefaultExt := FILE_FILTER_DFLT_VOLUMES;

    if OpenDialog.Execute() then
      begin
      MountFiles(ftLinux, TStringList(OpenDialog.Files), (ofReadOnly in OpenDialog.Options));
      end;
    end;

end;

procedure TfrmFreeOTFEMain.actLinuxMountPartitionExecute(Sender: TObject);
var
  selectedPartition: string;
  mountList: TStringList;
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    selectedPartition := OTFEFreeOTFE.SelectPartition();

    if (selectedPartition <> '') then
      begin
      mountList:= TStringList.Create();
      try
        mountList.Add(selectedPartition);
        MountFiles(ftLinux, mountList, FALSE);
      finally
        mountList.Free();
      end;

      end;
    end;

end;

procedure TfrmFreeOTFEMain.actPKCS11TokenManagementExecute(Sender: TObject);
begin
  OTFEFreeOTFE.ShowPKCS11ManagementDlg();
end;

procedure TfrmFreeOTFEMain.actPropertiesExecute(Sender: TObject);
begin
  DriveProperties();

end;

// Function required for both close and minimize to system tray icon
procedure TfrmFreeOTFEMain.actExitExecute(Sender: TObject);
begin
  // Either:
  //   Application.Terminate();
  // Or:
  SDUSystemTrayIcon1.Active := FALSE;
  Close();
end;

procedure TfrmFreeOTFEMain.miOptionsClick(Sender: TObject);
var
  dlg: TfrmOptions;
begin
  dlg := TfrmOptions.Create(self);
  try
    dlg.OTFEFreeOTFE := OTFEFreeOTFE;
    if (dlg.ShowModal() = mrOK) then
      begin
      ReloadSettings();
      EnableDisableControls();
      end;
      
  finally
    dlg.Free();
  end;

end;

// Function required for both close and minimize to system tray icon
procedure TfrmFreeOTFEMain.actDisplayConsoleExecute(Sender: TObject);
begin
  SDUSystemTrayIcon1.DoRestore();

end;


procedure TfrmFreeOTFEMain.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  userConfirm: WORD;
  oldActive: boolean;
  closingDrivesMounted: integer;
begin
  CanClose := TRUE;

  closingDrivesMounted := 0;

  // This code segment is required to handle the case when Close() is called
  // programatically
  // Only carry out this action if closing to SystemTrayIcon
  // Note the MainForm test; if it was not the main form, setting Action would
  // in FormClose would do the minimise
  if (
      not(EndSessionFlag) and
      SDUSystemTrayIcon1.Active and
      Settings.OptSystemTrayIconCloseTo and
{$IFDEF VER185}
      (
       // If Application.MainFormOnTaskbar is set, use the form name,
       // otherwise check exactly
       (
        Application.MainFormOnTaskbar and
        (application.mainform <> nil) and
        (application.mainform.name = self.name)
       ) or
       (
        not(Application.MainFormOnTaskbar) and
//        (application.mainform = self)
        (application.mainform <> nil) and
        (application.mainform.name = self.name)
       )
      )
{$ELSE}
      (Application.MainForm = self)
{$ENDIF}
     ) then
    begin
    CanClose := FALSE;
    SDUSystemTrayIcon1.DoMinimizeToIcon();
    end;

  if (CanClose) then
    begin
    oldActive := OTFEFreeOTFE.Active;
    // We (quite reasonably) assume that if the FreeOTFE component is *not*
    // active, and we can't activate it, then no FreeOTFE volumes are mounted
    if not(OTFEFreeOTFE.Active) then
      begin
      // Prevent any warnings...
      ShuttingDownFlag := TRUE;
      ActivateFreeOTFEComponent(FALSE);
      // Reset flag
      ShuttingDownFlag := FALSE;
      end;

    if (OTFEFreeOTFE.Active) then
      begin
      if (OTFEFreeOTFE.CountDrivesMounted() > 0) then
        begin
        userConfirm := SDUMessageDlg(
                                  _('One or volumes are still mounted.')+SDUCRLF+
                                  SDUCRLF+
                                  _('Do you wish to dismount all volumes before exiting?'),
                                  mtConfirmation, [mbYes, mbNo, mbCancel], 0
                                 );

        if (userConfirm = mrCancel) then
          begin
          CanClose := FALSE;
          end
        else if (userConfirm = mrYes) then
          begin
          CanClose := DismountAll();
          end
        else
          begin
          CanClose := TRUE;
          end;

        end;

      closingDrivesMounted := OTFEFreeOTFE.CountDrivesMounted();
      end;  // if (OTFEFreeOTFE.Active) then

    if not(oldActive) then
      begin
      // Prevent any warnings...
      ShuttingDownFlag := TRUE;
      DeactivateFreeOTFEComponent();
      // Reset flag
      ShuttingDownFlag := FALSE;
      end;

    end;


  if (CanClose) then
    begin
    // If there's no drives mounted, and running in portable mode, prompt for
    // portable mode shutdown
    if (
        (closingDrivesMounted <= 0) and
        (OTFEFreeOTFE.DriversInPortableMode() > 0)
       ) then
      begin
      userConfirm := SDUMessageDlg(
                                 _('One or more FreeOTFE drivers is running in portable mode.')+SDUCRLF+
                                 SDUCRLF+
                                 _('Do you wish to shutdown portable mode before exiting?'),
                                 mtConfirmation, [mbYes, mbNo, mbCancel], 0);

      if (userConfirm = mrCancel) then
        begin
        CanClose := FALSE;
        end
      else if (userConfirm = mrYes) then
        begin
        ShuttingDownFlag := TRUE;
        CanClose := PortableModeSet(pmaStop, FALSE);
        ShuttingDownFlag := CanClose;
        end
      else
        begin
        CanClose := TRUE;
        end;

      end;

    end;  // if (CanClose) then

  if CanClose then
    begin
    ShutdownPKCS11();
    DestroySysTrayIconMenuitems();
    Application.ProcessMessages();
    Application.UnhookMainWindow(MessageHook);
    OTFEFreeOTFE.Active := FALSE;
    end;

end;


// Function required for close to system tray icon
// Note: This is *only* required in your application is you intend to call
//       Close() to hide/close the window. Calling Hide() instead is preferable
procedure TfrmFreeOTFEMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // This code segment is required to handle the case when Close() is called
  // programatically
  // Only carry out this action if closing to SystemTrayIcon
  // Note the MainForm test; if it was the main form, setting Action would have
  // no effect
  if (
      not(EndSessionFlag) and
      SDUSystemTrayIcon1.Active and
      Settings.OptSystemTrayIconCloseTo and
{$IFDEF VER185}
      (
       // If Application.MainFormOnTaskbar is set, use the form name,
       // otherwise check exactly
       (
        Application.MainFormOnTaskbar and
        (application.mainform <> nil) and
        (application.mainform.name = self.name)
       ) or
       (
        not(Application.MainFormOnTaskbar) and
//        lplp
//        (application.mainform <> self)
        (application.mainform <> nil) and
        (application.mainform.name = self.name)
       )
      )
{$ELSE}
      (Application.MainForm <> self)
{$ENDIF}
     ) then
    begin
    Action := caMinimize;
    end
  else
    begin
    IconMounted.Free();
    IconMounted := nil;
    IconUnmounted.Free();
    IconUnmounted := nil;
    end;

end;


// This is used to ensure that only one copy of FreeOTFE is running at any
// given time
function TfrmFreeOTFEMain.MessageHook(var msg: TMessage): boolean;
var
  retVal: boolean;
  hotKeyMsg: TWMHotKey;
begin
  retVal := FALSE;

  if (msg.Msg = GLOBAL_VAR_WM_FREEOTFE_RESTORE) then
    begin
    // Restore application
    actDisplayConsole.Execute();

    msg.Result := 0;
    retVal := TRUE;
    end
  else if (msg.Msg = GLOBAL_VAR_WM_FREEOTFE_REFRESH) then
    begin
    actRefreshExecute(nil);
    msg.Result := 0;
    retVal := TRUE;
    end
  else if (msg.Msg = WM_HOTKEY) then
    begin
    // Hotkey window message handler
    hotKeyMsg := TWMHotKey(msg);

    if OTFEFreeOTFE.Active then
      begin
      if (hotKeyMsg.HotKey = HOTKEY_IDENT_DISMOUNT) then
        begin
        // We'll allow errors in dismount to be reported to the user; it's just
        // a normal dismount
        DismountAll(FALSE);
        end
      else if (hotKeyMsg.HotKey = HOTKEY_IDENT_DISMOUNTEMERG) then
        begin
        // Panic! The user pressed the emergency dismount hotkey! Better not
        // report any errors to the user
        DismountAll(TRUE);
        end;
      end;

      if (
          (hotKeyMsg.HotKey = HOTKEY_IDENT_DISMOUNT) or
          (hotKeyMsg.HotKey = HOTKEY_IDENT_DISMOUNTEMERG)
         ) then
        begin
        msg.Result := 0;
        retVal := TRUE;
        end;

    end;

  Result := retVal;
end;



// Cleardown and setup hotkeys
procedure TfrmFreeOTFEMain.SetupHotKeys();
begin
  // Cleardown any existing hotkeys...
  DisableHotkey(HOTKEY_IDENT_DISMOUNT);
  DisableHotkey(HOTKEY_IDENT_DISMOUNTEMERG);

  // ...And setup hotkeys again
  if Settings.OptHKeyEnableDismount then
    begin
    EnableHotkey(
                 Settings.OptHKeyKeyDismount,
                 HOTKEY_IDENT_DISMOUNT
                );
    end;

  if Settings.OptHKeyEnableDismountEmerg then
    begin
    EnableHotkey(
                 Settings.OptHKeyKeyDismountEmerg,
                 HOTKEY_IDENT_DISMOUNT
                );
    end;

end;

// Enable the specified shortcut as a hotkey, which will callback using the
// given identifier
procedure TfrmFreeOTFEMain.EnableHotkey(hotKey: TShortCut; hotKeyIdent: integer);
var
  modifiers : integer;
  vk  : word;
  shiftState : TShiftState;
begin
  if (hotkey = TextToShortCut(HOTKEY_TEXT_NONE)) then
    begin
    DisableHotkey(hotkeyIdent);
    end
  else
    begin
    // Obtain the virtual keycode and shiftState
    ShortCutToKey(hotkey, vk, shiftState);

    // Convet TShiftState into a modifier value for RegisterHotKey
    modifiers := 0;
    if (ssCtrl in shiftState) then
      begin
      modifiers := modifiers OR MOD_CONTROL;
      end;
    if (ssAlt in shiftState) then
      begin
      modifiers := modifiers OR MOD_ALT;
      end;
    if (ssShift in shiftState) then
      begin
      modifiers := modifiers OR MOD_SHIFT;
      end;

    DisableHotkey(hotkeyIdent);
    if not(RegisterHotkey(Application.Handle, hotkeyIdent, modifiers, vk)) then
      begin
      SDUMessageDlg(
                 Format(_('Error: Unable to assign hotkey %s'), [ShortCutToText(hotkey)]),
                 mtError
                );
      end;

    end;

end;

// Disable the hotkey with the specifid identifier
procedure TfrmFreeOTFEMain.DisableHotkey(hotKeyIdent: integer);
begin
  UnRegisterHotkey(Application.Handle, hotkeyIdent);
end;


procedure TfrmFreeOTFEMain.actTogglePortableModeExecute(Sender: TObject);
begin
  if (
      actTogglePortableMode.Enabled and
      (CountPortableDrivers < 0)
     ) then
    begin
    PortableModeSet(pmaToggle, FALSE);
    end
  else if actTogglePortableMode.checked then
    begin
    PortableModeSet(pmaStop, FALSE);
    end
  else
    begin
    PortableModeSet(pmaStart, FALSE);
    end;

  CountPortableDrivers := OTFEFreeOTFE.DriversInPortableMode();
  EnableDisableControls();

end;

procedure TfrmFreeOTFEMain.actUserGuideExecute(Sender: TObject);
var
  cwd: string;
  userGuide: string;
begin
  // Determine full path to local userguide
  cwd := ParamStr(0);
  cwd := ExtractFilePath(cwd);
  userGuide := cwd + '\' + USERGUIDE_LOCAL;

  // If local userguide doens't exist, fallback to online version...
  if not(FileExists(userGuide)) then
    begin
    userGuide := USERGUIDE_ONLINE;
    end;

  // Open HTML userguide
  ShellExecute(
               self.Handle,
               PChar('open'),
               PChar(userGuide),
               PChar(''),
               PChar(''),
               SW_SHOW
              );

end;

procedure TfrmFreeOTFEMain.lvDrivesSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  EnableDisableControls();

end;

procedure TfrmFreeOTFEMain.actFormatExecute(Sender: TObject);
resourcestring
  FORMAT_CAPTION = 'Format';
var
  i: integer;
  currDrive: char;
  driveNum: word;
begin
  for i:=0 to (lvDrives.items.count-1) do
    begin
    if lvDrives.Items[i].Selected then
      begin
      currDrive := GetDriveLetterFromLVItem(lvDrives.Items[i]);
      driveNum := ord(currDrive) - ord('A');
      SHFormatDrive(Handle, driveNum, SHFMT_ID_DEFAULT, SHFMT_OPT_FULL);
      end;
    end;

  // This is *BIZARRE*.
  // If you are running under Windows Vista, and you mount a volume for
  // yourself only, and then try to format it, the format will fail - even if
  // you UAC escalate to admin
  // That's one thing - HOWEVER! After it fails, for form's title is set to:
  //   Format <current volume label> <drive letter>:
  // FREAKY!
  // OTOH, it does means we can detect and inform the user that the format
  // just failed...
  if (Pos(uppercase(FORMAT_CAPTION), uppercase(self.Caption)) > 0) then
    begin
    self.Caption := Application.Title;
    SDUMessageDlg(
                  _('Your encrypted drive could not be formatted at this time.')+SDUCRLF+
                  SDUCRLF+
                  _('Please dismount this volume and remount it with the "Mount for all users" option checked, before trying again.'),
                  mtError,
                  [mbOK],
                  0
                 );
    end;

  RefreshDrives();

end;

procedure TfrmFreeOTFEMain.actOverwriteEntireDriveExecute(Sender: TObject);
var
  i: integer;
  selectedDrive: string;
begin
  if (lvDrives.SelCount > 1) then
    begin
    SDUMessageDlg(
                  _('Due to the destructive nature of overwriting entire drives, only one drive may be selected when this option is chosen.')+SDUCRLF+
                  SDUCRLF+
                  _('Please ensure that only one mounted drive is selected, and retry.')
                 );
    end
  else
    begin
    for i:=0 to (lvDrives.items.count-1) do
      begin
      if lvDrives.Items[i].Selected then
        begin
        selectedDrive := GetDriveLetterFromLVItem(lvDrives.Items[i]);
        break;
        end;
      end;

    if SDUConfirmYN(
                    _('WARNING!')+SDUCRLF+
                    SDUCRLF+
                    Format(_('You are are attempting to overwrite drive: %s:'), [selectedDrive])+SDUCRLF+
                    SDUCRLF+
                    Format(_('THIS WILL DESTROY ALL INFORMATION STORED ON DRIVE %s:, and require it to be reformatted'), [selectedDrive])+SDUCRLF+
                    SDUCRLF+
                    _('Are you ABSOLUTELY SURE you want to do this?')
                   ) then
      begin
      OverwriteSelectedDrives(TRUE);
      end;
    end;
end;


procedure TfrmFreeOTFEMain.actOverwriteFreeSpaceExecute(Sender: TObject);
begin
  OverwriteSelectedDrives(FALSE);
end;

// overwriteEntireDrive - Set to TRUE to overwrite the entire drive; this will
//                        destroy all data on the drive, and requiring it to be
//                        reformatted. Set to FALSE to simply overwrite the
//                        free space on the drive
procedure TfrmFreeOTFEMain.OverwriteSelectedDrives(overwriteEntireDrive: boolean);
var
  shredder: TShredder;
  i: integer;
  currDrive: char;
  frmOverWriteMethod: TfrmFreeOTFESelectOverwriteMethod;
  overwriteWithEncryptedData: boolean;
  allOK: boolean;
  getRandomBits: integer;
  getRandomBytes: integer;
  randomBuffer: array of byte;
  overwriteOK: integer;
  currDriveDevice: string;
  failMsg: string;
begin
  overwriteOK := 0;
  allOK := FALSE;
  overwriteWithEncryptedData := FALSE;

  frmOverWriteMethod:= TfrmFreeOTFESelectOverwriteMethod.Create(self);
  try
    frmOverWriteMethod.OTFEFreeOTFEObj := OTFEFreeOTFE;
    if (frmOverWriteMethod.ShowModal() = mrOK) then
      begin
      allOK := TRUE;

      overwriteWithEncryptedData := frmOverWriteMethod.OverwriteWithEncryptedData;
      if (overwriteWithEncryptedData) then
        begin
        TempCypherDriver:= frmOverWriteMethod.CypherDriver;
        TempCypherGUID:= frmOverWriteMethod.CypherGUID;

        OTFEFreeOTFE.GetSpecificCypherDetails(TempCypherDriver, TempCypherGUID, TempCypherDetails);

        // Initilize zeroed IV for encryption
        TempCypherEncBlockNo := 0;

        // Get *real* random data for encryption key
        getRandomBits := 0;
        if (TempCypherDetails.KeySizeRequired < 0) then
          begin
          // -ve keysize = arbitary keysize supported - just use 512 bits
          getRandomBits := 512;
          end
        else if (TempCypherDetails.KeySizeRequired > 0) then
          begin
          // +ve keysize = specific keysize - get sufficient bits
          getRandomBits := TempCypherDetails.KeySizeRequired;
          end;

        if (getRandomBits>0) then
          begin
          MouseRNGDialog1.RequiredBits := getRandomBits;
          allOK := MouseRNGDialog1.Execute();
          end;

        if (allOK) then
          begin
          getRandomBytes := (getRandomBits div 8);
          SetLength(randomBuffer, getRandomBytes);
          MouseRNGDialog1.RandomData(getRandomBytes, randomBuffer);

          for i:=low(randomBuffer) to high(randomBuffer) do
            begin
            TempCypherKey := TempCypherKey + char(randomBuffer[i]);
            // Overwrite the temp buffer...
            randomBuffer[i] := random(256);
            end;
          SetLength(randomBuffer, 0);
          end;

        end;

      end;

  finally
    frmOverWriteMethod.Free();
  end;



  if (allOK) then
    begin
    if (SDUMessageDlg(
                   _('Overwriting on a large volume may take awhile.')+SDUCRLF+
                   SDUCRLF+
                   _('Are you sure you wish to proceed?'),
                    mtConfirmation,
                   [mbYes,mbNo],
                   0
                  ) = mrYes) then
      begin
      shredder:= TShredder.Create(nil);
      try
        shredder.IntMethod := smPseudorandom;
        shredder.IntPasses := 1;

        if overwriteWithEncryptedData then
          begin
          // Note: Setting this event overrides shredder.IntMethod
          shredder.OnOverwriteDataReq := GenerateOverwriteData;
          end
        else
          begin
          shredder.OnOverwriteDataReq := nil;
          end;


        for i:=0 to (lvDrives.items.count-1) do
          begin
          if lvDrives.Items[i].Selected then
            begin
            currDrive := GetDriveLetterFromLVItem(lvDrives.Items[i]);

            if overwriteEntireDrive then
              begin
              currDriveDevice := '\\.\'+currDrive+':';
              shredder.DestroyDevice(currDriveDevice, FALSE, FALSE);
              overwriteOK := shredder.LastIntShredResult;
              end
            else
              begin
              overwriteOK := shredder.OverwriteDriveFreeSpace(currDrive, FALSE);
              end;

            end;
          end;

        if (overwriteOK = 1) then
          begin
          SDUMessageDlg(_('Overwrite operation complete.'), mtInformation);
          if overwriteEntireDrive then
            begin
            SDUMessageDlg(_('Please reformat the drive just overwritten before attempting to use it.'), mtInformation);
            end;
          end
        else if (overwriteOK = -1) then
          begin
          failMsg := _('Overwrite operation FAILED.');
          if not(overwriteEntireDrive) then
            begin
            failMsg := failMsg + SDUCRLF+
                       SDUCRLF+
                       _('Did you remember to format this drive first?');
            end;

          SDUMessageDlg(failMsg, mtError);
          end
        else if (overwriteOK = -2) then
          begin
          SDUMessageDlg(_('Overwrite operation cancelled by user.'), mtInformation);
          end
        else
          begin
          SDUMessageDlg(_('No drives selected to overwrite?'), mtInformation);
          end;


      finally
        shredder.Free();
      end;

    end;  // if (SDUMessageDlg(
  end;  // if (allOK) then

  TempCypherDriver:= '';
  TempCypherGUID:= StringToGUID('{00000000-0000-0000-0000-000000000000}');
  TempCypherKey := '';
  TempCypherEncBlockNo := 0;

end;

procedure TfrmFreeOTFEMain.pbtbTogglePortableModeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  // This is ugly, but required since if the button is clicked on, and the
  // operation cancelled, the button pops up - even though it shouldn't!
  pbtbTogglePortableMode.down  := (CountPortableDrivers > 0);

end;


// Handle "/portable" command line
// Returns: Exit code
function TfrmFreeOTFEMain.HandleCommandLineOpts_Portable(): integer;
var
  exitCode: integer;
  paramValue: string;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;
  if SDUCommandLineParameter(CMDLINE_PORTABLE, paramValue) then
    begin
    if (uppercase(paramValue) = uppercase(CMDLINE_TOGGLE)) then
      begin
      if PortableModeSet(
                         pmaToggle,
                         SDUCommandLineSwitch(CMDLINE_SILENT)
                        ) then
        begin
        exitCode := CMDLINE_SUCCESS;
        end
      else
        begin
        exitCode := CMDLINE_EXIT_UNABLE_TO_START_PORTABLE_MODE;
        end;
      end
    else if (
             (uppercase(paramValue) = uppercase(CMDLINE_START)) or
             (uppercase(paramValue) = uppercase(CMDLINE_ON)) or
             (paramValue = '1')
            ) then
      begin
      if PortableModeSet(
                         pmaStart,
                         SDUCommandLineSwitch(CMDLINE_SILENT)
                        ) then
        begin
        exitCode := CMDLINE_SUCCESS;
        end
      else
        begin
        exitCode := CMDLINE_EXIT_UNABLE_TO_START_PORTABLE_MODE;
        end;
      end
    else if (
             (uppercase(paramValue) = uppercase(CMDLINE_STOP)) or
             (uppercase(paramValue) = uppercase(CMDLINE_OFF)) or
             (paramValue = '0')
            ) then
      begin
      if PortableModeSet(
                         pmaStop,
                         SDUCommandLineSwitch(CMDLINE_SILENT)
                        ) then
        begin
        exitCode := CMDLINE_SUCCESS;
        end
      else
        begin
        exitCode := CMDLINE_EXIT_UNABLE_TO_STOP_PORTABLE_MODE;
        end;
      end
    end;

  Result := exitCode;
end;

// Handle "/install" command line
//
// !! IMPORTANT !!
// NOTICE: THIS DOES NOT CARRY OUT ANY UAC ESCALATION!
//         User should use "runas FreeOTFE.exe ..." if UAC escalation
//         required
// !! IMPORTANT !!
//
// Returns: Exit code
function TfrmFreeOTFEMain.HandleCommandLineOpts_DriverControl_Install(driverControlObj: TOTFEFreeOTFEDriverControl): integer;
var
  exitCode: integer;
  paramValue: string;
  driverPathAndFilename: string;
  driverFilenames: TStringList;
  silent: boolean;
  vista64Bit: boolean;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;

  if SDUCommandLineParameter(CMDLINE_FILENAME, paramValue) then
    begin
    silent := SDUCommandLineSwitch(CMDLINE_SILENT);

    if (uppercase(trim(paramValue)) = uppercase(CMDLINE_ALL)) then
      begin
      exitCode := CMDLINE_EXIT_UNKNOWN_ERROR;

      driverFilenames:= TStringList.Create();
      try
        GetAllDriversUnderCWD(driverFilenames);

        if (driverFilenames.count <= 0) then
          begin
          exitCode := CMDLINE_EXIT_FILE_NOT_FOUND;
          end
        else
          begin
          // If under Vista x64, don't autostart the drivers after
          // installing - this could cause a bunch of *bloody* *stupid*
          // warning messages about "unsigned drivers" to be displayed by
          // the OS
          vista64Bit := (SDUOSVistaOrLater() and SDUOS64bit());
          if driverControlObj.InstallMultipleDrivers(
                                                     driverFilenames,
                                                     FALSE,
                                                     not(silent),
                                                     not(vista64Bit)
                                                    ) then
            begin
            exitCode := CMDLINE_SUCCESS;

            // If Vista x64, we tell the user to reboot. That way, the drivers
            // will be started up on boot - and the user won't actually see
            // any stupid warning messages about "unsigned drivers"
            if (
                vista64Bit and
                not(silent)
               ) then
              begin
              SDUMessageDlg(
                            _('IMPORTANT: Please see the documentation for additional steps to be carried out after installing under this OS.'),
                            mtInformation
                           );
              end;
            end;
          end;

      finally
        driverFilenames.Free();
      end;

      end
    else
      begin
      // Convert any relative path to absolute
      driverPathAndFilename := SDURelativePathToAbsolute(paramValue);

      // Ensure driver file actually exists(!)
      if not(fileexists(driverPathAndFilename)) then
        begin
        exitCode := CMDLINE_EXIT_FILE_NOT_FOUND;
        end
      else
        begin
        exitCode := CMDLINE_EXIT_UNKNOWN_ERROR;
        if driverControlObj.InstallSetAutoStartAndStartDriver(paramValue) then
          begin
          exitCode := CMDLINE_SUCCESS;
          end;
        end;
      end;
    end;

  Result := exitCode;
end;


// Handle "/uninstall" command line
//
// !! IMPORTANT !!
// NOTICE: THIS DOES NOT CARRY OUT ANY UAC ESCALATION!
//         User should use "runas FreeOTFE.exe ..." if UAC escalation
//         required
// !! IMPORTANT !!
//
// Returns: Exit code
function TfrmFreeOTFEMain.HandleCommandLineOpts_DriverControl_Uninstall(driverControlObj: TOTFEFreeOTFEDriverControl): integer;
var
  exitCode: integer;
  paramValue: string;
  driveUninstallResult: DWORD;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;

  if SDUCommandLineParameter(CMDLINE_DRIVERNAME, paramValue) then
    begin
    exitCode := CMDLINE_EXIT_UNKNOWN_ERROR;
    if (uppercase(trim(paramValue)) = uppercase(CMDLINE_ALL)) then
      begin
      if driverControlObj.UninstallAllDrivers(FALSE) then
        begin
        exitCode := CMDLINE_SUCCESS;
        end;
      end
    else
      begin
      driveUninstallResult := driverControlObj.UninstallDriver(paramValue);

      if ((driveUninstallResult AND DRIVER_BIT_SUCCESS) = DRIVER_BIT_SUCCESS) then
        begin
        exitCode := CMDLINE_SUCCESS;
        end;
      end;

    end;

  Result := exitCode;
end;


// Returns: Exit code
function TfrmFreeOTFEMain.HandleCommandLineOpts_DriverControl_GUI(): integer;
var
  exitCode: integer;
begin
  actDriversExecute(nil);
  exitCode := CMDLINE_SUCCESS;

  Result := exitCode;
end;

function TfrmFreeOTFEMain.HandleCommandLineOpts_DriverControl(): integer;
var
  exitCode: integer;
  paramValue: string;
  driverControlObj: TOTFEFreeOTFEDriverControl;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;
  try
    if SDUCommandLineParameter(CMDLINE_DRIVERCONTROL, paramValue) then
      begin
      // Special case; this one can UAC escalate
      if (uppercase(paramValue) = uppercase(CMDLINE_GUI)) then
        begin
        exitCode := HandleCommandLineOpts_DriverControl_GUI();
        end
      else
        begin
        // Creating this object needs admin privs; if the user doesn't have
        // these, it'll raise an exception
        driverControlObj := TOTFEFreeOTFEDriverControl.Create();
        try
          driverControlObj.Silent := SDUCommandLineSwitch(CMDLINE_SILENT);

          // This first test is redundant
          if (uppercase(paramValue) = uppercase(CMDLINE_GUI)) then
            begin
            exitCode := HandleCommandLineOpts_DriverControl_GUI();
            end
          else if (uppercase(paramValue) = uppercase(CMDLINE_COUNT)) then
            begin
            exitCode := HandleCommandLineOpts_DriverControl_Count(driverControlObj);
            end
          else if (uppercase(paramValue) = uppercase(CMDLINE_INSTALL)) then
            begin
            exitCode := HandleCommandLineOpts_DriverControl_Install(driverControlObj);
            end
          else if (uppercase(paramValue) = uppercase(CMDLINE_UNINSTALL)) then
            begin
            exitCode := HandleCommandLineOpts_DriverControl_Uninstall(driverControlObj);
            end;

          finally
            driverControlObj.Free();
          end;
        end;

      end;

    except
      on E:EFreeOTFENeedAdminPrivs do
        begin
        exitCode := CMDLINE_EXIT_ADMIN_PRIVS_NEEDED;
        end;
    end;
        
  Result := exitCode;
end;


// Handle "/install" command line
// Returns: Exit code
function TfrmFreeOTFEMain.HandleCommandLineOpts_DriverControl_Count(driverControlObj: TOTFEFreeOTFEDriverControl): integer;
var
  exitCode: integer;
  paramValue: string;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;

  // If "/type" not specified, default to the total
  if not(SDUCommandLineParameter(CMDLINE_TYPE, paramValue)) then
  begin
    paramValue := CMDLINE_TOTAL;
  end;

  if (uppercase(paramValue) = uppercase(CMDLINE_TOTAL)) then
    begin
    exitCode := driverControlObj.CountDrivers();
    end
  else if (uppercase(paramValue) = uppercase(CMDLINE_DRIVERSPORTABLE)) then
    begin
    exitCode := driverControlObj.CountDrivers(TRUE);
    end
  else if (uppercase(paramValue) = uppercase(CMDLINE_DRIVERSINSTALLED)) then
    begin
    exitCode := driverControlObj.CountDrivers(FALSE);
    end;

  Result := exitCode;
end;


// Handle "/count" command line
// Returns: Exit code
function TfrmFreeOTFEMain.HandleCommandLineOpts_Count(): integer;
var
  exitCode: integer;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;

  if SDUCommandLineSwitch(CMDLINE_COUNT) then
    begin
    exitCode := OTFEFreeOTFE.CountDrivesMounted();
    end;

  Result := exitCode;
end;

// Handle "/mount" command line
// Returns: Exit code
function TfrmFreeOTFEMain.HandleCommandLineOpts_Mount(): integer;
var
  exitCode: integer;
  volume: string;
  readonly: boolean;
  mountAs: string;
  fileOK: boolean;
  useDriveLetter: string;
  useKeyfile: string;
  useLESFile: string;
  usePassword: string;
  useSilent: boolean;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;

  if SDUCommandLineParameter(CMDLINE_VOLUME, volume) then
    begin
    fileOK := TRUE;

    SetupOTFEComponent();

    readonly := SDUCommandLineSwitch(CMDLINE_READONLY);
    if not(SDUCommandLineParameter(CMDLINE_PASSWORD, usePassword)) then
      begin
      usePassword := '';
      end;
    useSilent := SDUCommandLineSwitch(CMDLINE_SILENT);

    if SDUCommandLineParameter(CMDLINE_DRIVE, useDriveLetter) then
      begin
      if (length(useDriveLetter) = 0) then
        begin
        fileOK := FALSE;
        end
      else
        begin
        OTFEFreeOTFE.DefaultDriveLetter := (uppercase(useDriveLetter))[1];
        end;
      end;

    useKeyfile := '';
    if SDUCommandLineParameter(CMDLINE_KEYFILE, useKeyfile) then
      begin
      if (length(useKeyfile) = 0) then
        begin
        fileOK := FALSE;
        end
      else
        begin
        useKeyfile := SDURelativePathToAbsolute(useKeyfile);
        if not(FileExists(useKeyfile)) then
          begin
          exitCode := CMDLINE_EXIT_FILE_NOT_FOUND;
          fileOK := FALSE;
          end;
        end;
      end;

    useLESFile := '';
    if SDUCommandLineParameter(CMDLINE_LESFILE, useLESFile) then
      begin
      if (length(useLESFile) = 0) then
        begin
        fileOK := FALSE;
        end
      else
        begin
        useLESFile := SDURelativePathToAbsolute(useLESFile);
        if not(FileExists(useLESFile)) then
          begin
          exitCode := CMDLINE_EXIT_FILE_NOT_FOUND;
          fileOK := FALSE;
          end;
        end;
      end;

    // Convert any relative path to absolute, based on CWD - but not if a
    // device passed through!
    if (Pos(uppercase(DEVICE_PREFIX), uppercase(volume)) <= 0) then
      begin
      volume := SDURelativePathToAbsolute(volume);
      if not(FileExists(volume)) then
        begin
        exitCode := CMDLINE_EXIT_FILE_NOT_FOUND;
        fileOK := FALSE;
        end;
      end;

    if fileOK then
      begin
      if SDUCommandLineSwitch(CMDLINE_FREEOTFE) then
        begin
        mountAs := OTFEFreeOTFE.MountFreeOTFE(
                                              volume,
                                              readOnly,
                                              useKeyfile,
                                              usePassword,
                                              useSilent
                                             );
        end
      else if SDUCommandLineSwitch(CMDLINE_LINUX) then
        begin
        mountAs := OTFEFreeOTFE.MountLinux(
                                           volume,
                                           readOnly,
                                           useLESFile,
                                           usePassword,
                                           useSilent
                                          );
        end
      else if (useLESFile <> '') then
        begin
        mountAs := OTFEFreeOTFE.MountLinux(
                                           volume,
                                           readOnly,
                                           useLESFile,
                                           usePassword,
                                           useSilent
                                          );
        end
      else if (useKeyfile <> '') then
        begin
        mountAs := OTFEFreeOTFE.MountFreeOTFE(
                                              volume,
                                              readOnly,
                                              useKeyfile,
                                              usePassword,
                                              useSilent
                                             );
        end
      else if (Settings.OptDragDropFileType = ftFreeOTFE) then
        begin
        mountAs := OTFEFreeOTFE.MountFreeOTFE(
                                              volume,
                                              readOnly,
                                              useKeyfile,
                                              usePassword,
                                              useSilent
                                             );
        end
      else if (Settings.OptDragDropFileType = ftLinux) then
        begin
        mountAs := OTFEFreeOTFE.MountLinux(
                                           volume,
                                           readOnly,
                                           useLESFile,
                                           usePassword,
                                           useSilent
                                          );
        end
      else
        begin
        mountAs := OTFEFreeOTFE.Mount(volume, readOnly);
        end;

      if (mountAs <> #0) then
        begin
        exitCode := CMDLINE_SUCCESS;
        end
      else
        begin
        exitCode := CMDLINE_EXIT_UNABLE_TO_MOUNT;
        end;

      end;
    end;

  Result := exitCode;
end;


// Handle "/unmount" command line
// Returns: Exit code
function TfrmFreeOTFEMain.HandleCommandLineOpts_Dismount(): integer;
var
  exitCode: integer;
  paramValue: string;
  force: boolean;
  drive: char;
  dismountOK: boolean;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;

  if SDUCommandLineParameter(CMDLINE_DISMOUNT, paramValue) then
    begin
    force := SDUCommandLineSwitch(CMDLINE_FORCE);
    
    if (uppercase(paramValue) = uppercase(CMDLINE_ALL)) then
      begin
      dismountOK := (OTFEFreeOTFE.DismountAll(force) = '');
      end
    else
      begin
      // Only use the 1st char...
      drive := paramValue[1];

      dismountOK := OTFEFreeOTFE.Dismount(drive, force);
      end;

    if dismountOK then
      begin
      exitCode := CMDLINE_SUCCESS;
      end
    else
      begin
      exitCode := CMDLINE_EXIT_UNABLE_TO_DISMOUNT;
      end;
    end;

  Result := exitCode;
end;

// Handle any command line options; returns TRUE if command line options
// were passed through, and "/noexit" wasn't specified as a command line
// parameter
function TfrmFreeOTFEMain.HandleCommandLineOpts(var exitCode: integer): boolean;
var
  paramValue: string;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;

  AllowUACEsclation := not(SDUCommandLineSwitch(CMDLINE_NOUACESCALATE));

  // Driver control dialog
  if SDUCommandLineSwitch(CMDLINE_DRIVERCONTROL) then
    begin
    exitCode := HandleCommandLineOpts_DriverControl();
    end
  // Portable mode on/off...
  else if SDUCommandLineParameter(CMDLINE_PORTABLE, paramValue) then
    begin
    exitCode := HandleCommandLineOpts_Portable();
    end
  else if SDUCommandLineParameter(CMDLINE_DRIVERCONTROL, paramValue) then
    begin
    exitCode := HandleCommandLineOpts_DriverControl();
    end
  else
    begin
    // All command line options below require FreeOTFE to be active before they
    // can be used
    if not(ActivateFreeOTFEComponent(TRUE)) then
      begin
      exitCode := CMDLINE_EXIT_UNABLE_TO_CONNECT;
      end
    else
      begin
      if SDUCommandLineSwitch(CMDLINE_COUNT) then
        begin
        exitCode := HandleCommandLineOpts_Count();
        end
      else if SDUCommandLineSwitch(CMDLINE_MOUNT) then
        begin
        exitCode := HandleCommandLineOpts_Mount();
        end
      else if SDUCommandLineParameter(CMDLINE_DISMOUNT, paramValue) then
        begin
        exitCode := HandleCommandLineOpts_Dismount();
        end;

      DeactivateFreeOTFEComponent();
      end;
    end;

  // Return TRUE if there were no parameters specified on the command line
  // and "/noexit" wasn't specified
  Result := (
             (ParamCount > 0) and
             not(SDUCommandLineSwitch(CMDLINE_NOEXIT))
            );
end;


{$IFDEF VER180}
{$IFNDEF VER185}
// Vista fix for Delphi 2006 only
procedure TfrmFreeOTFEMain.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  if SDUOSVistaOrLater() then
    begin
    Params.ExStyle := Params.ExStyle and not WS_EX_TOOLWINDOW or WS_EX_APPWINDOW;
    end;

end;
{$ENDIF}
{$ENDIF}

{$IFDEF VER180}
{$IFNDEF VER185}
// Vista fix for Delphi 2006 only
procedure TfrmFreeOTFEMain.WMSyscommand(var Message: TWmSysCommand);
begin
  if not(SDUOSVistaOrLater()) then
    begin
    inherited;
    end
  else
    begin
    case (Message.CmdType and $FFF0) of
      SC_MINIMIZE:
        begin
        ShowWindow(Handle, SW_MINIMIZE);
        Message.Result := 0;
        end;

      SC_RESTORE:
        begin
        ShowWindow(Handle, SW_RESTORE);
        Message.Result := 0;
        end;

    else
      begin
      inherited;
      end;

    end;
  end;

end;
{$ENDIF}
{$ENDIF}

procedure TfrmFreeOTFEMain.UACEscalateForDriverInstallation();
begin
  UACEscalate(CMDLINE_SWITCH_IND + CMDLINE_DRIVERCONTROL + ' ' +CMDLINE_GUI, FALSE);
end;

procedure TfrmFreeOTFEMain.UACEscalateForPortableMode(portableAction: TPortableModeAction; suppressMsgs: boolean);
var
  cmdLinePortableSwitch: string;
begin
  case portableAction of
    pmaStart:
      begin
      cmdLinePortableSwitch := CMDLINE_START;
      end;

    pmaStop:
      begin
      cmdLinePortableSwitch := CMDLINE_STOP;
      end;

    pmaToggle:
      begin
      cmdLinePortableSwitch := CMDLINE_TOGGLE;
      end;

  end;
  
  UACEscalate(
              CMDLINE_SWITCH_IND + CMDLINE_PORTABLE+ ' ' +cmdLinePortableSwitch,
              suppressMsgs
             );

end;

procedure TfrmFreeOTFEMain.UACEscalate(cmdLineParams: string; suppressMsgs: boolean);
const
  VERB_RUNAS = 'runas';
var
  filenameAndPath: string;
  cwd: string;
begin
  // Only applicable in Windows Vista; simply warn user they can't continue on
  // earlier OSs
  if (
      not(SDUOSVistaOrLater()) or
      not(AllowUACEsclation)
     ) then
    begin
    if not(suppressMsgs) then
      begin
      SDUMessageDlg(TEXT_NEED_ADMIN, mtError, [mbOK], 0);
      end;
    end
  else
    begin
    // Prevent endless loops of UAC escalation...
    cmdLineParams := CMDLINE_SWITCH_IND + CMDLINE_NOUACESCALATE +
                     ' ' + cmdLineParams;

    // Message supression
    if suppressMsgs then
      begin
      cmdLineParams := CMDLINE_SWITCH_IND + CMDLINE_SILENT +
                       ' ' + cmdLineParams;
      end;

    filenameAndPath := ParamStr(0);
    cwd := ExtractFilePath(filenameAndPath);
    ShellExecute(
                 self.Handle,
                 VERB_RUNAS,
                 PChar(filenameAndPath),
                 PChar(cmdLineParams),
                 PChar(cwd),
                 SW_SHOW
                );

    // The UAC escalation/reexecution of FreeOTFE as UAC may have changed the
    // drivers installed/running; flush any caches in the FreeOTFE object
    OTFEFreeOTFE.CachesFlush();
    end;

end;

procedure TfrmFreeOTFEMain.SetupPKCS11(suppressMsgs: boolean);
var
  tmpPKCS11Lib: TPKCS11Library;
begin
  ShutdownPKCS11();

  tmpPKCS11Lib := nil;
  if (
      Settings.OptPKCS11Enable and
      (Settings.OptPKCS11Library <> '')
     ) then
    begin
    try
      tmpPKCS11Lib := TPKCS11Library.Create(Settings.OptPKCS11Library);
      tmpPKCS11Lib.OnSlotEvent := PKCS11SlotEvent;
      tmpPKCS11Lib.Initialize();
      PKCS11Library := tmpPKCS11Lib;
      OTFEFreeOTFE.PKCS11Library := PKCS11Library;
    except
      on E:Exception do
        begin
        if not(suppressMsgs) then
          begin
          SDUMessageDlg(
                        _('Unable to initialize PKCS#11 support:')+SDUCRLF+
                        SDUCRLF+
                        E.Message,
                        mtError
                       );
          end;
          
        if (tmpPKCS11Lib <> nil) then
          begin
          tmpPKCS11Lib.Free();
          end;
        end;
    end;
    
    end;
    
end;

procedure TfrmFreeOTFEMain.ShutdownPKCS11();
begin
  // Sanity; strip from FreeOTFE copmponent
  OTFEFreeOTFE.PKCS11Library := nil;

  if (PKCS11Library <> nil) then
    begin
    try
      PKCS11Library.Finalize();
      PKCS11Library.Free();
    except
      on E:Exception do
        begin
        // Just swallow it - if there's a problem, there's nothing we can do
        // about it
        end;
    end;
    end;

  PKCS11Library := nil;
end;

procedure TfrmFreeOTFEMain.PKCS11TokenRemoved(SlotID: integer);
var
  i: integer;
  volumeInfo: TOTFEFreeOTFEVolumeInfo;
  drivesToDismount: string;
  mounted: string;
begin
  SetStatusBarText(Format(_('Detected removal of token from slot ID: %d'), [SlotID]));
  if Settings.OptPKCS11AutoDismount then
    begin
    drivesToDismount := '';
    mounted := OTFEFreeOTFE.DrivesMounted();
    for i:=1 to length(mounted) do
      begin
      // ...Main FreeOTFE window list...
      if OTFEFreeOTFE.GetVolumeInfo(mounted[i], volumeInfo) then
        begin
        if volumeInfo.MetaDataStructValid then
          begin
          if (volumeInfo.MetaDataStruct.PKCS11SlotID = SlotID) then
            begin
            drivesToDismount := drivesToDismount + mounted[i];
            end;
          end;
        end;
      end;

    SetStatusBarText(Format(_('Autodismounting drives: %s'), [PrettyPrintDriveLetters(drivesToDismount)]));
    DismountDrives(drivesToDismount, FALSE);
    end;

end;

procedure TfrmFreeOTFEMain.PKCS11TokenInserted(SlotID: integer);
var
  tmpFilename: TStringList;
  mountNameOnly: string;
begin
  SetStatusBarText(Format(_('Detected insertion of token into slot ID: %d'), [SlotID]));
  if Settings.OptPKCS11AutoMount then
    begin
    // Attempt automount...
    tmpFilename := TStringList.Create;
    try
      tmpFilename.Add(Settings.OptPKCS11AutoMountVolume);
      mountNameOnly := ExtractFilename(Settings.OptPKCS11AutoMountVolume);
      SetStatusBarText(Format(_('Automounting: %s'), [mountNameOnly]));
      MountFilesDetectLUKS(
                           tmpFilename,
                           FALSE,
                           Settings.OptDragDropFileType
                          );
    finally
      tmpFilename.Free();
    end;

    end;

end;

procedure TfrmFreeOTFEMain.PKCS11SlotEvent(Sender: TObject; SlotID: integer);
var
  lib: TPKCS11Library;
  slot: TPKCS11Slot;
begin
  // Sanity check; we can't do anything if FreeOTFE component's not available
  if OTFEFreeOTFE.Active then
    begin
    SetStatusBarText(Format(_('Slot event on slot ID: %d'), [SlotID]));

    lib := TPKCS11Library(Sender);
    slot := lib.SlotByID[SlotID];
    if (slot = nil) then
      begin
      // Assume token removed, and the PKCS#11 driver dynamically removes the
      // slot when that happens
      PKCS11TokenRemoved(SlotID);
      end
    else
      begin
      if slot.TokenPresent then
        begin
        PKCS11TokenInserted(SlotID);
        end
      else
        begin
        PKCS11TokenRemoved(SlotID);
        end;
      end;

    RefreshDrives();
    end;
end;

// Change CWD to anywhere other than a mounted drive
// This must be done before any dismount, in case the user changed the CWD to a
// dir stored within the drive to be dismounted (e.g. by mounting another
// volume stored within that mounted drive - the mount dialog would change the
// CWD)
procedure TfrmFreeOTFEMain.ChangeCWDToSafeDir();
var
  windowsDir: string;
begin
  windowsDir := SDUGetSpecialFolderPath(SDU_CSIDL_WINDOWS);
  SDUSetCurrentWorkingDirectory(windowsDir);
end;

END.


